
#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <stack>
#include <queue>
#include <complex>
#include <random>
#include <chrono>


using namespace std;
using namespace __gnu_pbds;



/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

/*#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,tune=native")
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")*/

#define int long long
#define ll long long
//#define int short int
#define eb emplace_back
#define pb push_back
#define ld long double
//#define ld double
#define mp make_pair
#define f first
#define s second
#define gleg(x) return cout << x, 0
#define pii pair <int, int>
#define deb(a) cerr << #a << " = " << a << '\n';
//#define sz(x) (int)s.size();
#define fast() {     ios_base::sync_with_stdio(0);     cin.tie(0);     cout << fixed << setprecision(9);     cerr << fixed << setprecision(12); }


typedef tree <
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set ;


const int INF = 1e18 + 7;
const ld EPS = 1e-6;
const int MAXI = 350;
const int MOD = 998244353;
const int MOD1 = 1e9 + 7;
const int MAXST = 2000000;
const int P = 31;
const int P1 = 37;
const int N = 5100000;
const ld PI = 3.14159265358979323;
const int bp = 23;
//const int sz = 1 << bp;


ostream &operator<<(ostream &stream, const pair <int, int> &p) {
    stream << p.first << ' ' << p.second << ' ';
    return stream;
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

clock_t tStart = clock();

struct T{
    ld x, y;

    T(){
        x = y = 0;
    }

    T(ld _x, ld _y){
        x = _x, y = _y;
    }

    ld len(){
        return sqrt(x * x + y * y);
    }

    void norm(){
        x /= len();
        y /= len();
    }

    void mult(ld k){
        x *= k;
        y *= k;
    }

    void del(ld k){
        x /= k;
        y /= k;
    }
};



ld operator ^ (T a, T b){
    return a.x * b.y - a.y * b.x;
}

ld operator * (T a, T b){
    return a.x * b.x + a.y * b.y;
}

T operator + (T a, T b){
    return T(a.x + b.x, a.y + b.y);
}

T operator - (T a, T b){
    return T(a.x - b.x, a.y - b.y);
}

vector <vector <int>> sp;
int n, m;

void do_sp(vector <int> &dp){
    for (int i = -n; i <= n; i++){
        sp[i + n][0] = dp[i + n];
    }

    for (int i = 1; (1 << i) - 1 < n * 2 + 2; i++){
        for (int j = 0; j + (1 << i) - 1 <  n * 2 + 2; j++){
            sp[j][i] = min(sp[j][i - 1], sp[j + (1 << (i - 1))][i - 1]);
        }
    }
}

vector <int> lg;

int get_min(int l, int r){
    int log = lg[r - l + 1];
    return min(sp[l][log], sp[r - (1 << log) + 1][log]);
}

signed main(){
    fast();
    srand(time(0));
//    #ifdef LOCAL
    //freopen("stacks.in", "r", stdin);
    //freopen("stacks.out", "w", stdout);
//    #endif

    cin >> n >> m;
    lg.resize(n * 2 + 10, -1);
    lg[0] = 0;
    for (int i = 1; (1 << i) < lg.size(); i++){
        lg[(1 << i)] = i;
    }

    for (int i = 0, cur = -1; i < lg.size(); i++){
        if (lg[i] == -1)
            lg[i] = cur;
        else
            cur++;
    }


    vector <pair <int, int>> a(m);
    sp.resize(n * 2 + 2, vector <int> (23));
    for (auto &i: a) {
        cin >> i.f >> i.s;
        i.f--, i.s--;
    }

    vector <vector <int>> dp(m, vector <int> (n * 2 + 2, INF));
    for (int i = -n; i <= n; i++){
        if (a[0].f + i >= 0 && a[0].s + i < n)
            dp[0][i + n] = abs(i);
    }

    for (int i = 1; i < m; i++){
        do_sp(dp[i - 1]);
        for (int j = -n; j <= n; j++){
            if (a[i].f + j >= 0 && a[i].s + j < n) {
                int l = a[i].f + j - a[i - 1].s, r = a[i].s + j - a[i - 1].f;
                if (l > r)
                    swap(l, r);
                dp[i][j + n] = min(INF, abs(j) + get_min(l + n, r + n));
            }
        }
    }

    int ans = INF;
    for (int i = 0; i < n * 2 + 2; i++){
        ans = min(ans, dp[m - 1][i]);
    }

    cout << ans << '\n';
    return 0;
}
