#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
	int n, a, b;
	cin >> n >> a >> b;
	
	vector<pair<pair<int, int>, int>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first.first;
	}
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first.second;
	}
	for (int i = 0; i < n; i++) {
		arr[i].second = i;
	}

	sort(arr.begin(), arr.end(), [](pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
		return a.first.first - a.first.second >= b.first.first - b.first.second;
	});

	string str(n, 'T');
	int ans = 0;
	for (int i = 0; i < a; i++) {
		ans += arr[i].first.first;
	}
	for (int i = a; i < n-b; i++) {
		if (arr[i].first.first > arr[i].first.second) {
			ans += arr[i].first.first;
		} else {
			ans += arr[i].first.second;
			str[arr[i].second] = 'P';
		}
	}
	for (int i = n-b; i < n; i++) {
		ans += arr[i].first.second;
		str[arr[i].second] = 'P';
	}

	cout << ans << '\n';
	for (int i = 0; i < n; i++)
		cout << str[i] << ' ';
	return 0;
}
