#include <bits/stdc++.h>
using namespace std;

#define len(a) ((int)((a).size()))
#define all(a) a.begin(), a.end()
#define add push_back
#define mkp make_pair
#define fr first
#define sc second
#define endl '\n'
using namespace std;

typedef long long ll;
typedef pair<long long, long long> pll;
typedef pair<int, int> pii;


const int N = 2e5 + 5;

long long n, m, x;
vector<int> g[N];
long long a[N];
long long color[N];
long long ans = 0;

void bfs(int v){
	queue<int> q;
	q.push(v);
	while(!q.empty()){
		v = q.front();
		q.pop();
		long long cnt = color[v];
		if(a[v] >= cnt) cnt /= 2;

		if(v == n) ans = cnt; 

		for(int i = 0; i < len(g[v]); i++){
			int to = g[v][i];
			if(cnt > color[to]) {
				if(color[to] == -1) q.push(to);
				color[to] = cnt;
			}
		}
	}
}

void solve(){
	cin >> n >> m;
	for(int i = 0; i < m; i++){
		int u, v;
		cin >> u >> v;
		g[u].add(v);
		g[v].add(u);
	}
	cin >> x;
	for(int i = 1; i <= n; i++){
		cin >> a[i];
	}
	fill(color, color + N, -1);
	color[1] = x;
	bfs(1);
	cout << ans << endl;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
	return 0;
}
