#include <bits/stdc++.h>

using namespace std;

vector<vector<long long> > ddata;

long long find_min(long long k) {
    sort(ddata[k].begin(), ddata[k].end());
    long long l = 0;
    for (long long i = 0; i < k; ++i) {
        while (l < ddata[k].size() && ddata[k][l] < i) {
            l++;
        }
        if (l >= ddata[k].size()) {
            return i;
        }
        if (ddata[k][l] != i) {
            return i;
        }
        l++;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(12);
    long long n;
    cin >> n;
    ddata.resize(n);
    long long ans[n];
    long long pr[n + 1];
    fill(pr, pr + n + 1, 0);
    fill(ans, ans + n, 0);
    for (long long i = 0; i < n; ++i) {
        long long x = find_min(i);
        cout << "? " << x + 1 << ' ' << i + 1 << endl;
        long long a, b, c;
        cin >> a;
        cin >> b;
        cin >> c;
        ans[i] = a - (pr[i] - pr[x]);
        pr[i + 1] = pr[i] + ans[i];
        ddata[c - 1].push_back(b - 1);
    }
    cout << "!" << endl;
    for (long long i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    return 0;
}
