#include <bits/stdc++.h>

#define ll long double
#define endl '\n'
#define ios ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);

using namespace std;

const ll EPS = 1e-7;
ll x, t, t3, t6;

ll eff(ll v) {
    ll k1 = x / t6,
       k2 = (100.0 - x)/(t3-t6);
    if(t6 - v > EPS) {
        return k1 * v;
    } else {
        return k2 * (v - t6) + x;
    }
}

ll f(ll v) {
    return eff(v)*(t - v);
}

int main() {
    ios
    cin >> x >> t;
    t6 = t/6;
    t3 = t/3;
    double l = 0, r = t3;
    for(int i=0; i<1e6; i++) {
        ll m1=l+(r-l)/3, m2=r-(r-l)/3;
       if (f(m1) < f(m2))
          l = m1;
       else
          r = m2;
    }
    cout << fixed << setprecision(7) << f(l);
}
