#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
 
char nl = '\n';
 
typedef long long ll;
typedef long double dbl;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef double db;
using Int = int;
 
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int ll
 
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
//#pragma comment(linker, "/STACK:200000000")
 
//ifstream cin1("gift1.in");
//ofstream cout1("gift1.out");

typedef tree<
pair<int, int>,
null_type,
less<pair<int, int>>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

vector<int> paths[200001];
int d[200001];

bool cmp(int A, int B){
	return d[A] < d[B];
}

int bfs(int x, int n){
	vector<int> now(200001);
	vector<bool> was(200001);
	now[1] = x;
	priority_queue<pair<int, int>> wh;
	wh.push({x, 1});
	while(wh.size() > 0){
		auto t = wh.top();
		wh.pop();
		if(was[t.second]) continue;
		for(int i : paths[t.second]){
			if(was[i]) continue;
			int temp = (t.first > d[i] ? t.first : t.first / 2);
			if(now[i] < temp){
				now[i] = temp;
				wh.push({temp, i});
			}
		}
		was[t.second] = true;
	}
	return now[n];
}

void solve() {
	int n, m;
	cin >> n >> m;
	for(int i = 0; i < m; ++i){
		int u, v;
		cin >> v >> u;
		paths[v].push_back(u);
		paths[u].push_back(v);
	}
	int x;
	cin >> x;
	for(int i = 1; i <= n; ++i){
		cin >> d[i];
	}
	for(int i = 1; i <= n; ++i){
		sort(all(paths[i]), cmp);
	}
	cout << bfs(x > d[1] ? x : x / 2, n);
}   
 
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
	int t = 1;
    //cin >> t;
	while (t--) {
		solve();
	}
}