#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
 
using it = int;
using ll = long long;
using dl = double long;
using dd = double;
using ch = char;
using str = string;
using ull = unsigned long long;

/* Defines: */
#define will_do do
#define lb lower_bound
#define ub upper_bound
#define von void
#define m_s tolower /* make the letter small */
#define m_b toupper /* make the letter big */
#define finish_code(); return 0;
#define popb pop_back
#define pb push_back
#define perviy first
#define vtoroy second
#define eb emplace_back
#define pf push_front
#define n_p next_permutation
#define con continue

template<class T> void mini(T& a, T b) { a = min(a, b); }
template<class T> void maxi(T& a, T b) { a = max(a, b); }
template<class T1, class T2> ostream& operator<<(ostream &out, pair<T1, T2> a) { return out << a.first << " " << a.second; }
template<class T> ostream& operator<<(ostream& out, vector<T> a) { for (auto& i : a) out << i << " "; return out; }
template<class T> ostream& operator<<(ostream& out, set<T> a) { for (auto& i : a) out << i << " "; return out; }
template<class T> ostream& operator<<(ostream& out, multiset<T> a) { for (auto& i : a) out << i << " "; return out; }
template<class T1, class T2> ostream& operator<<(ostream& out, map<T1, T2> a) { for (auto& i : a) out << i << "\n"; return out; }
template<class T1, class T2> ostream& operator<<(ostream& out, unordered_map<T1, T2> a) { for (auto& i : a) out << i << "\n"; return out; }
template<class T> ostream& operator<<(ostream& out, queue<T> a) { while (!a.empty()) { out << a.front() << " "; a.pop(); } return out; }
template<class T> ostream& operator<<(ostream& out, deque<T> a) { while (!a.empty()) { out << a.front() << " "; a.pop_front(); } return out; }
template<class T> ostream& operator<<(ostream& out, priority_queue<T> a) { while (!a.empty()) { out << a.top() << "\n"; a.pop(); } return out; }
template<class T> void out(T a) { cout << a << endl; }
template<class T1, class T2> void out(T1 a, T2 b) { cout << a << " " << b << endl; }
template<class T1, class T2, class T3> void out(T1 a, T2 b, T3 c) { cout << a << " " << b << " " << c << endl; }
template<class T1, class T2, class T3, class T4> void out(T1 a, T2 b, T3 c, T4 d) { cout << a << " " << b << " " << c << " " << d << endl; }
template<class T> void out(vector<vector<T>> a) { for (vector<T> i : a) out(i); }
template<class T> void out_(T a[], int l, int r) { for (int i = l; i <= r; i++) cout << a[i] << " "; cout << endl; }
void out() { cout << "OK" << endl; }
template<class T> void sort(vector<T>& a) { sort(a.begin(), a.end()); }
template<class T> void uniq(vector<T>& a) { sort(a); a.erase(unique(a.begin(), a.end()), a.end()); }
template<class T> vector<T> set_int(vector<T> a, vector<T> b) { sort(a); sort(b); vector<T> res; set_intersection(a.begin(), a.end(), b.begin(), b.end(), back_inserter(res)); return res; }
clock_t start_time; void start_timer() { start_time = clock(); }
double get_time() { return (double)(clock() - start_time) / CLOCKS_PER_SEC; }
#if _SIZEOF_INT128_ >= 16
typedef __int128 LL;
istream& operator>>(istream& in, __int128& a) { int64_t b; cin >> b; a = b; return in; }
ostream& operator<<(ostream& out, const __int128 a) {
	unsigned __int128 b = a < 0 ? -a : a; char buf[128]; char* c = end(buf); do { --c; *c = "0123456789"[b % 10]; b /= 10; } while (b);
	if (a < 0) { --c; *c = '-'; } int len = end(buf) - c; out.rdbuf()->sputn(c, len); return out;
}
#endif

/* 
============================================================================================================================================
For vector:
 - push_back() = dobavit element v konec
 - pop_back() = udalit poslednii element v vectore
 - push_front() = dobavit element v na4ale
 - pop_front() = udalit pervii element v vectore
 - erase() = udalit opredelenii element(elementi) v vectore // Naprimer: a.erase(a.begin+1) = udalit vtoroy element
 - insert() = dobavit element v opredelinnim meste v vectore // Naprimer: a.insert(a.begin()+3, 6) = dobavit 6 v chetvertom meste
 
============================================================================================================================================
 
For set:
 - insert() = dobavit element v sete
 - erase() = udalit element v sete
 - find() = proverit, est li tam opredelinii element libo net
 
============================================================================================================================================
 
For deque:
 
 - push_back() = dobavit element v konec
 - pop_back() = udalit poslednii element v deque
 - push_front() = dobavit element v na4ale
 - pop_front() = udalit pervii element v deque
 - front() = uznat pervii element v deque(ne udalia ego)
 - back() = uznat poslednii element v deque(ne udalia ego)
 - empty() = proverit, est li tam elementi libo net
 
============================================================================================================================================
 
Useful and necessary chips:
    ----------------------------
    |cout.precision(20);       |
    |cout << fixed << (answer);|
    ----------------------------
    
    cout << (proviso) ? (answer 1) : (answer 2);
    
============================================================================================================================================
 
*/
 
const int N = 1e2 + 7;
const int inf = 1e9 + 7;
const int INF = 1e18 + 7;

void speed_up() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
}

void answer() {
    it n, m, k; cin >> n >> m >> k;
    if (k > n or k > m) {
        cout << "Impossible"; exit(0);
    }
    it prov = 0;
    cout << "Possible" << '\n';
    for (it i = 1; i <= n; i++) {
        for (it j = 1; j <= m; j++) {
            if (i == j && prov < k) {
                cout << '*'; prov++;
            }
            else cout << '.';
        }
        cout << '\n';
    }
    exit(0);
}
 
signed main() {
    speed_up();
    //freopen("ladder.in", "r", stdin);
    //freopen("ladder.out", "w", stdout);
    answer();
    finish_code();
}