# include<bits/stdc++.h>

# define ll long long
# define fi first
# define se second
# define pb push_back
# define pob pop_back
# define pf push_front
# define pof pop_front

const ll N = 1e6 + 10;
const ll INF = 1e18;
const ll inf = 535344;
const ll MOD = 1e9 + 7;

using namespace std;
ll n, m;
ll lg[100005];
vector <vector <ll>> get_sparse(vector <ll> a)
{
    vector <vector <ll>> mn(n + 1, vector <ll>(lg[n] + 1, LLONG_MAX));
    for(ll i = 1; i <= n; ++i)
        mn[i][0] = a[i];
    for(ll j = 1; j <= lg[n]; ++j)
        for(ll i = 1; i + (1 << j) - 1<= n; ++i)
            mn[i][j] = min(mn[i][j - 1], mn[i + (1 << (j - 1))][j - 1]);
    return mn;
}

void solve()
{
    cin >> n >> m;
    vector <pair<ll, ll>> a(m + 1);
    for(ll i = 1; i <= m; ++i)
        cin >> a[i].fi >> a[i].se;
    vector <ll> dp1(n + 1, LLONG_MAX);
    vector <ll> dp2(n + 1, LLONG_MAX);
    for(ll i = 1; i + a[1].se - a[1].fi <= n; ++i)
        dp2[i] = abs(a[1].fi - i);

    for(ll i = 2; i <= m; ++i)
    {
        dp1 = dp2;
        dp2.clear();
        dp2.resize(n + 1, LLONG_MAX);
        auto sparse = get_sparse(dp1);
        for(ll j = 1; j + a[i].se - a[i].fi <= n; ++j)
        {
            dp2[j] = abs(j - a[i].fi);
            ll x = max(1LL, j - (a[i - 1].se - a[i - 1].fi));
            ll y = j + a[i].se - a[i].fi;
            ll len = y - x + 1;
            ll lg1 = lg[len];
            dp2[j] += min(sparse[x][lg1], sparse[y - (1 << lg1) + 1][lg1]);
        }
//        for(ll j = 1; j <= n; ++j)
//            cout << dp2[j] << " ";
//        cout << "\n";
    }
    ll mn = LLONG_MAX;
    for(ll i = 1; i <= n; ++i)
        mn = min(mn, dp2[i]);
    cout << mn;
}

int main()
{
    ios_base::sync_with_stdio(0);
    int o = 1;
    lg[1] = 0;
    for(ll i = 2; i <= 1e5; ++i)
        lg[i] = lg[i >> 1] + 1;
    //cin >> o;
    while(o--)
    {
        solve();
    }
}
/**
1 1 4
int6910
epelahitino
**/
