#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}

const double EPS = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<double> x(n), v(n);
    for(int i = 0; i < n; ++i) {
        cin >> x[i] >> v[i];
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            vector<double> t(n);
            int always = 0;
            for (int k = 0; k < n; ++k) {
                double xk = x[j] + (x[i] - x[j]) * (k - j) / (i - j), vk = v[j] + (v[i] - v[j]) * (k - j) / (i - j);
                if (abs(vk - v[k]) < EPS && abs(xk - x[k]) < EPS) {
                    always++;
                } else {
                    t[k] = (x[k] - xk) / (v[k] - vk);
                }
            }
            sort(all(t));
            dbg(always);
            dbg(t);
            int cur = always;
            res = max(res, always);
            for (int k = 0; k < n && t[k] < 0; ++k) {
                if (k > 0 && t[k] < 0 && abs(t[k] - t[k - 1]) < EPS) cur++;
                else {
                    res = max(res, cur);
                    cur = always + 1;
                }
            }
        }
    }
    cout << res << endl;
}

int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
