#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}

int len(ll i) {
    int p = 1;
    while ((1ll << p) < i) p++;
    return ((1 << p) == i ? p : p - 1);
}

void solve() {
   int n;
   cin >> n;
   ll xa = 0, xb = 0, xx = 0;
   vector<ll> a(n), b(n), x(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        xa ^= a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        xb ^= b[i];
    }
    for (int i = 0; i < n; ++i) {
        x[i] =  a[i] ^ b[i];
    }
    xx = xa ^ xb;
    ll res = xa + xb;
    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int a, int b) { return x[a] > x[b];});
    sort(rall(x));
    int maxl = len(x[0]);
    vector<vector<int>> bits(maxl + 1);
    vector<ll> s(maxl + 1);
    for (int i = 0; i < n; ++i) {
        if (s[len(x[i])] == 0) {
            s[len(x[i])] = x[i];
            bits[len(x[i])].push_back(p[i]);
        }
        if (i < n - 1 && s[len(x[i] ^ x[i + 1])] == 0) {
            s[len(x[i] ^ x[i + 1])] = x[i] ^ x[i + 1];
            bits[len(x[i] ^ x[i + 1])].push_back(p[i]);
            bits[len(x[i] ^ x[i + 1])].push_back(p[i + 1]);
        }
    }
    vector<int> ans(n);
    for(int i = maxl; i > 0; --i) {
        if (xx + 2 * ((xa ^ s[i]) & (xb ^ s[i])) > res) {
            res = xx + 2 * ((xa ^ s[i]) & (xb ^ s[i]));
            xa ^= s[i];
            xb ^= s[i];
            for(auto e : bits[i]) {
                ans[e] ^= 1;
            }
        }
    }

    cout << res << ' ' << count(all(ans), 1) << endl;
    for (int i = 0; i < n; ++i)  {
        if (ans[i]) cout << i + 1 << ' ';
    }
    cout << endl;
}

int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
