#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL); cout.tie(NULL);

	int n, m; cin >> n >> m;
	int C = n - 1;

	vector<pair<int, int>> a(m);
	for (auto& c : a) {
		cin >> c.first >> c.second;
		c.first--;
		c.second--;
	}
	
	vector<int> dp(2 * n, inf);
	int l = a[0].first, r = a[0].second;
	for (int cur_x = -l; cur_x <= n - 1 - r; cur_x++) {
		dp[cur_x + C] = abs(cur_x);
	}

	for (int j = 1; j < m; j++) {
		l = a[j].first, r = a[j].second;
		vector<int> cur_dp(2 * n, inf);
		for (int cur_x = -l; cur_x <= n - 1 - r; cur_x++) {
			//for (int pred = -n + 1; pred <= n - 1; pred++) {
			//	if (pred >= l + cur_x - a[j - 1].second && pred <= r + cur_x - a[j - 1].first) {
			//		cur_dp[cur_x + C] = min(cur_dp[cur_x + C], dp[pred + C] + abs(cur_x));
			//	}
			//}

			for (int pred = max(-n + 1, l + cur_x - a[j - 1].second); pred <= min(n - 1, r + cur_x - a[j - 1].first); pred++) {
				cur_dp[cur_x + C] = min(cur_dp[cur_x + C], dp[pred + C] + abs(cur_x));
			}
		}

		dp = cur_dp;
	}

	int ans = inf;
	for (auto c : dp) {
		ans = min(ans, c);
	}
	cout << ans;

	return 0;
}