#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

int main() {

	int n, a, b;
	cin >> n >> a >> b;
	vector<ll>x(n), y(n);
	vector<pair<ll, int>> v(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i];
	for (int i = 0; i < n; ++i) {
		cin >> y[i];
		v[i].first = y[i] - x[i];
		v[i].second = i;
	}
	sort(v.rbegin(),v.rend());
	vector<char> ans(n, ' ');
	for (int i = 0; i < b; ++i)
		ans[v[i].second] = 'P';
	for (int i = n - 1; i >= n - a; --i)
		ans[v[i].second] = 'T';
	for (int i = 0; i < n; ++i)
		if (ans[v[i].second] == ' ') {
			if (v[i].first >= 0)
				ans[v[i].second] = 'P';
			else
				ans[v[i].second] = 'T';
		}
	ll sum = 0;
	for (int i = 0; i < n; ++i)
		if (ans[i] == 'P')
			sum += y[i];
		else
			sum += x[i];
	cout << sum << '\n';
	for (int i = 0; i < n; ++i)
		cout << ans[i] << ' ';
	return 0;
}