import java.io.*;
import java.util.StringTokenizer;

public class Main {

    public static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    public static StringTokenizer tokenizer = null;

    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void flush() throws IOException {
        writer.flush();
    }

    public static void println() throws IOException {
        writer.newLine();
    }

    public static void print(String s) throws IOException {
        writer.write(s);
    }

    public static void println(String s) throws IOException {
        print(s);
        println();
    }


    public static void main(String[] args) throws IOException {
        taskA();
    }

    public static void taskA() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int k = nextInt();
        int min = Math.min(n, m);
        if (k <= min) {
            println("Possible");
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) print(i == j ? "*" : ".");
                println();
            }
        } else println("Impossible");
        flush();
    }

}