import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class H {

    public static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    public static StringTokenizer tokenizer = null;

    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void flush() throws IOException {
        writer.flush();
    }

    public static void println() throws IOException {
        writer.newLine();
    }

    public static void print(String s) throws IOException {
        writer.write(s);
    }

    public static void println(String s) throws IOException {
        print(s);
        println();
    }

    public static void main(String[] args) throws IOException {
        taskH();
    }

    public static void taskH() throws IOException {
        BigInteger a = new BigInteger(next());
        BigInteger b = new BigInteger(next());
        List<String> commands = new ArrayList<>();
        while (a.signum() != 0 && b.signum() != 0) {
            if (a.abs().compareTo(b.abs()) >= 0) {
                BigInteger k = a.divide(b);
                a = a.subtract(b.multiply(k));
                commands.add("1 " + k.negate());
            } else {
                BigInteger k = b.divide(a);
                b = b.subtract(a.multiply(k));
                commands.add("2 " + k.negate());
            }
        }
        println(commands.size() + "");
        for (int i = 0; i < commands.size(); i++) println(commands.get(i));
        flush();
    }




}
