#include <bits/stdc++.h>

#define ll long long

using namespace std;

signed main() {
    ll n, m;
    cin >> n >> m;
    ll start = 0, finish = n - 1;
    
    vector<vector<ll>> a(n, vector<ll>(n, -1));
    vector < pair < ll, ll > > inp;
    for (ll i = 0; i < m; i++){
        ll u, v; cin >> u >> v;
        u --;  v --;
        inp.push_back({u, v});
    }
    ll clones; cin >> clones;
    vector < ll > dr(n);
    for (ll i = 0; i < n; i++){
        cin >> dr[i];
    }
    for (ll i = 0; i < m; i++){
        ll u = inp[i].first, v = inp[i].second;
        a[u][v] = dr[v];
        a[v][u] = dr[u];
    }

    set < pair < ll, ll > > s;
    vector < ll > p(n, -1);
    vector < ll > dist(n, 1e9);
    dist[start] = 0;
    s.insert({0, start});
    while (!s.empty()) {
        ll v = s.begin()->second;
        s.erase(s.begin());
        for (ll i = 0; i < n; i++) {
            if (a[v][i] != -1) {
                if (dist[i] > dist[v] + a[v][i]) {
                    s.erase({dist[i], i});
                    dist[i] = dist[v] + a[v][i];
                    p[i] = v;
                    s.insert({dist[i], i});
                }
            }
        }
    }
    ll qr = p[finish];
    vector < ll > ans;
    ans.push_back(n - 1);
    while (qr != -1){
        ans.push_back(qr);
        qr = p[qr];
    }
    reverse(ans.begin(), ans.end());
    for (auto x : ans){
        clones = clones / (1 + int(bool(clones <= dr[x])));
    }
    cout << clones;
    return 0;
}