#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
    for (T i : vec) {
        os << i << ' ';
    }
    return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
    for (vector<T> i : vec) {
        os << i << '\n';
    }
    return os;
}

vector<pair<int, int>> ans;

void gcd(int a, int b) {
	if (!a || !b)
		return;
	int c = a, d = b;
	int d1 = c % d, d2 = c % d - d, d6 = c % d + d, d3 = d % c, d4 = d % c - c, d5 = d % c + c;
	if (min({abs(d1), abs(d2), abs(d6)}) < min({abs(d3), abs(d4), abs(d5)})) {
		int u = min({abs(d1), abs(d2), abs(d6)});
		if (abs(d1) == u) {
			ans.push_back({1, - a / b});
			gcd(a % b, b);
		} else if (abs(d2) == u){
			ans.push_back({1, -a / b - 1});
			gcd(a % b - b, b);
		} else {
			ans.push_back({1, -a / b + 1});
			gcd(d6, b);
		}
	} else {
		int v = min({abs(d3), abs(d4), abs(d5)});
		if (abs(d3) == v) {
			ans.push_back({2, - b / a});
			gcd(a, b % a);
		} else if (abs(d4) == v) {
			ans.push_back({2, - b / a - 1});
			gcd(a, b % a - a);
		} else {
			ans.push_back({2, - b / a + 1});
			gcd(a, d5);
		}
	}
}

void solve() {
    int a, b;
    cin >> a >> b;
    gcd(a, b);
    cout << ans.size() << '\n';
    for (auto[i, j] : ans)
    	cout << i << " " << j << '\n';
}

int32_t main() {
    start;

    solve();

    finish;
}