#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ctime>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;

#define fast() {\
    ios_base::sync_with_stdio(false);\
    cin.tie(0);\
    cout << fixed << setprecision(0);\
}
#define op(){\
    freopen("input.txt", "r", stdin);\
    freopen("output.txt", "w", stdout);\
}

#define f first
#define s second
#define pb push_back
#define sqr(a) ((a) * (a))

using ll = long long;
using ld = long double;
using pi = array<int, 2>;
using pl = array<ll, 2>;
using pd = array<double, 2>;
using pld = array<ld, 2>;
using graph = vector<vector<ll> >;
using vll = vector<ll>;
using vii = vector<int>;
using vdd = vector<double>;

const ll INF = 1e+9 + 7;
const ll MEGAINF = 1e18 + 7;
const ll P = 31;
const ld EPS = 1e-6;
const ld PI = 3.14159265358979323;
const int MAXN = 1e6 + 10;
const int LOG = 30;


int main()
{
    fast();

    #ifdef _LOCAL
        clock_t Tsart = clock();
        op();
    #endif

    ll n, x;
    int l, r;
    cin >> n;
    vector<ll> used(n, 0), a(n, MEGAINF), pc(n, MEGAINF);

    for (int i = 0; i < n; i++) {
        if (used[i])
            continue;
        cout << "? " << i + 1 << ' ' << i + 1 << endl;
        cin >> x >> l >> r;
        l--, r--;
        used[i] = 1;
        a[i] = x;
        while (!used[r]) {
            if (l != r) {
                cout << "? " << r + 1 << ' ' << r + 1 << endl;
                cin >> x;
                a[r] = x;
                used[r] = 1;
                cin >> l >> r;
                l--, r--;

            } else {
                cout << "? " << 1 << ' ' << r + 1 << endl;
                cin >> x;
                pc[r] = x;
                used[r] = 1;
                cin >> l >> r;
                l--, r--;
            }
        }
    }
    pc[0] = a[0];
    for (int i = 0; i < n; i++) {
        if (pc[i] == MEGAINF)
            pc[i] = pc[i - 1] + a[i];
        else if (a[i] == MEGAINF)
            a[i] = pc[i] - pc[i - 1];
    }
    cout << "!\n";
    for (int i = 0; i < n; i++)
        cout << a[i] << ' ';


    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif

    return 0;
}
