#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace std;
using namespace __gnu_pbds;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

///pragms:

//#pragma GCC optimize("Ofast,O3,unroll-loops")

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native,avx2")

using ull = unsigned long long;
using ll = long long;
using ld = long double;
//using ui = unsigned int;

/*const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new ( size_t n ) {
	char *res = mem + mpos;
	mpos += n;
	assert(mpos <= MAX_MEM);
	return (void *)res;
}
inline void operator delete ( void * ) { }*/

mt19937 rnd(time(0));

ll mxrnd = (1ll << 32) - 1;

ld get_rand() {
    ld x = rnd();
    return x / mxrnd;
}

const int N = (int)1e5 + 1;

signed main() {
    ios;
    ld t0 = clock() / (ld) CLOCKS_PER_SEC;
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    vector<ll> c(n);
    for (ll &x : a)
        cin >> x;
    for (ll &x : b)
        cin >> x;
    for (int i = 0; i < n; ++i)
        c[i] = a[i] ^ b[i];
    ll x1 = 0;
    ll x2 = 0;
    for (ll x : a)
        x1 ^= x;
    for (ll x : b)
        x2 ^= x;
    ld t = 1;
    ld k = 0.999998;
    bitset<N> used;
    bitset<N> opt_used;
    ll sum = x1 + x2;
    ll opt_sum = x1 + x2;
    while ((clock() / (ld) CLOCKS_PER_SEC) - t0 < 0.9) {
        t *= k;
        int i = rnd() % n;
        ll X1 = x1 ^ c[i];
        ll X2 = x2 ^ c[i];
        ll cur = X1 + X2;
        if (cur > sum) {
            x1 = X1;
            x2 = X2;
            sum = cur;
            used[i] = !used[i];
            continue;
        }
        if (exp((ld)(cur - sum) / t) > get_rand()) {
            if (sum > opt_sum) {
                opt_sum = sum;
                opt_used = used;
            }
            x1 = X1;
            x2 = X2;
            sum = cur;
            used[i] = !used[i];
        }
    }
    ///cout << t << endl;
    if (sum > opt_sum) {
        opt_sum = sum;
        opt_used = used;
    }
    cout << opt_sum << ' ' << opt_used.count() << '\n';
    for (int i = 0; i < n; ++i) {
        if (opt_used[i])
            cout << i + 1 << ' ';
    }
    return 0;
}


