#include <bits/stdc++.h>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
constexpr int INF = (numeric_limits<int>::max()) / 2;
constexpr long long INFLL = (numeric_limits<long long>::max()) / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ld = double;
ld eps = 1e-8;

struct point {
    ld x, y;

    point() {};

    point(ld x, ld y) : x(x), y(y) {};
};

struct line {
    ld a, b, c;

    line() {};

    line(point p, point q) {
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
    }

    ld operator()(point p) {
        return a * p.x + b * p.y + c;
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<point> vv(n);
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        int si;
        cin >> si >> v[i];
        vv[i] = {(ld) si, (ld) i};
    }
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            vector<ld> t;
            int cur = 2;
            for (int k = 0; k < n; ++k) {
                if (k == i || k == j) {
                    continue;
                }
                auto check = [&](ld ti) -> int {
                    line gg({vv[i].x + (ld) v[i] * ti, vv[i].y}, {vv[j].x + (ld) v[j] * ti, vv[j].y});
                    point cur = {vv[k].x + (ld) v[k] * ti, vv[k].y};
                    if (gg(cur) > eps) {
                        return 1;
                    }
                    if (-eps <= gg(cur) && gg(cur) <= eps) {
                        return 0;
                    }
                    return -1;
                };
                if (check(0) == 0 && check(4e6) == 0) {
                    ++cur;
                } else {
                    ld x2 = vv[i].x - vv[j].x;
                    ld x3 = vv[i].x - vv[k].x;
                    ld y2 = vv[i].y - vv[j].y;
                    ld y3 = vv[i].y - vv[k].y;
                    ld ti = (x3 * y2 - x2 * y3) / ((v[i] - v[j]) * y3 - (v[i] - v[k]) * y2);
                    if (check(ti) == 0) {
                        t.push_back(ti);
                    }
                }
            }
            sort(all(t));
//            int p = 0;
//            for (int k = 0; k < t.size(); k++) {
//                while (p < t.size() && t[p] - t[k] <= eps) {
//                    p++;
//                }
//            }
            for (int k = 0; k < t.size(); ++k) {
                int curk = upper_bound(all(t), t[k] + eps) - t.begin() - k;
                ans = max(ans, curk + cur);
            }
            ans = max(ans, cur);
        }
    }
    cout << ans << "\n";
}