#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    int n, m;
    cin >> n >> m;
    vector g(n, vector<int>());
    for (int i = 0; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    int x;
    cin >> x;
    vector<int> d(n);
    for (auto &it : d) cin >> it;
    vector<char> used(n, 0);
    vector<int> ans(n, 0);
    if (x > d[0]) ans[0] = x;
    else ans[0] = x / 2;
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (used[u]) continue;
        used[u] = 1;
        for (auto v : g[u]) {
            if (used[v]) continue;
            if (ans[u] > d[v]) ans[v] = max(ans[v], ans[u]);
            else ans[v] = max(ans[v], ans[u] / 2);
            q.push(v);
        }
    }
    cout << ans[n - 1];
    return 0;
}
