#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <iostream>
#include <cstdlib>
#include <cctype>
#include <functional>
#include <sstream>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <random>
#include <chrono>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using db = long double;
using str = string;

#define SZ(sp) int((sp).size())
#define bgn(sp) (sp).begin()
#define rbgn(sp) (sp).rbegin()
#define all(sp) bgn(sp), (sp).end()
#define rall(sp) rbgn(sp), (sp).rend()
#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define rFOR(i,a,b) for (int i = (a); i >= (b); --i)
#define debugLine() cout << "\n------------\n";
#define ordered_set tree < pair < int, int >, null_type,less < pair < int, int > >, rb_tree_tag, tree_order_statistics_node_update >
#define indexed_multiset tree < int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>
//iterator = find_by_order(k-th); (0...n)
// element = order_of_key(x); number of elements smaller than x

const ll MOD1 = 1e18 + 3;
const ll MOD2 = 1000000123;
const ll INF = 1e13 + 7;
const db EPS = 1e-4;
const db PI = acos((db)-1);
const ll N = 100007;
const ll K = 200007;
const ll P = 53;
mt19937 rng((unsigned int) chrono::steady_clock::now().time_since_epoch().count());

#define int ll

void solve(int cnt_test=0) {
    int n, m;
    cin >> n >> m;
    vector < vector < int > > g(n + 1);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    int s = 1, f = n;
    int x;
    cin >> x;
    vector < int > arr(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> arr[i];
    }
    vector < int > dist(n + 1, INF);
    deque < pair < int, pair < int, int > > > q;
    dist[s] = 0;
    if (x > arr[s]) {
        q.emplace_back(mp(0, mp(x, 1)));
    }
    else {
        q.emplace_back(mp(0, mp(x / 2, 1)));
    }
    int ans = 0;
    while (!q.empty()) {
        auto p = q.front();
        q.pop_front();
        if (p.se.fi == 0) {
            continue;
        }
        if (p.se.se == f) {
            ans = p.se.fi;
            break;
        }
        for (int &v: g[p.se.se]) {
            if (dist[v] == INF) {
                dist[v] = p.fi + 1;
                if (p.se.fi > arr[v]) {
                    q.emplace_front(mp(dist[v], mp(p.se.fi, v)));
                }
                else {
                    q.emplace_back(mp(dist[v], mp(p.se.fi / 2, v)));
                }
            }
        }
    }
    cout << ans;
    cout << endl;
}

void precalc() {

}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    precalc();
    int tt = 1;
    //cin >> tt;
    for (int cnt_test = 1; cnt_test <= tt; ++cnt_test) {
        //cout << "Case #" << cnt_test << ":" << endl;
        solve(cnt_test);
        //debugLine();
    }
    return 0;
}