#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    int k;
    cin >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> d(n, 0);
    d[0] = k;
    set<pii> q;
    q.emplace(-d[0], 0);
    while (!q.empty()) {
        int w = -q.begin()->first, v = q.begin()->second;
        q.erase(q.begin());
        int now;
        if (w > a[v]) {
            now = w;
        }
        else {
            now = w / 2;
        }
        for (auto u: g[v]) {
            if (now > d[u]) {
                q.erase({-d[u], u});
                d[u] = now;
                q.emplace(-d[u], u);
            }
        }
    }
    int ans, w = d[n - 1];
    if (w > a[n - 1]) {
        ans = w;
    }
    else {
        ans = w / 2;
    }
    cout << ans << en;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}