#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve() {
    long double x, t;
    cin >> x >> t;
    long double ans = 0;

    ans = max(ans, (5 * t * x) / 6);
    ans = max(ans, (2 * t * 100) / 3);

    long double l = 0, r = 1;
    for(int i = 0; i < 500; i++)
    {
        long double m1 = l + (r - l) / 3;
        long double m2 = r - (r - l) / 3;

        long double t1 = (5 - m1) * t / 6;
        long double t2 = (5 - m2) * t / 6;

        long double x1 = x + (100 - x) * m1;
        long double x2 = x + (100 - x) * m2;

        long double ans1 = x1 * t1;
        long double ans2 = x2 * t2;

        if(ans2 < ans1)
        {
            r = m2;
        } else{
            l = m1;
        }
    }

    long double T = (5 - l) * t / 6;
    long double X = x + (100 - x) * l;

    ans = max(ans, X * T);

    l = 0;
    r = 1;
    for(int i = 0; i < 500; i++)
    {
        long double m1 = l + (r - l) / 3;
        long double m2 = r - (r - l) / 3;

        long double t1 = (6 - m1) * t / 6;
        long double t2 = (6 - m2) * t / 6;

        long double x1 = x * m1;
        long double x2 = x * m2;

        long double ans1 = x1 * t1;
        long double ans2 = x2 * t2;

        if(ans2 < ans1)
        {
            r = m2;
        } else{
            l = m1;
        }
    }

    T = (6 - l) * t / 6;
    X = x * l;

    ans = max(ans, X * T);

    cout << fixed << setprecision(10) << ans << endl;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}