﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <numeric>

typedef long long ll;
using num = long long;

using namespace std;
using std::cout;

num MAX = 4;

vector<pair<bool, ll>> res;

bool recur(num k, __int128 a, __int128 b)
{
    if (k == MAX)
    {
        num result = k;
        stringstream s;
        while (a != 0 && b != 0)
        {
            if (abs(a) > abs(b))
            {
                s << "1 " << -num(a / b) << '\n';
                a = a % b;
            }
            else
            {
                s << "2 " << -num(b / a) << '\n';
                b = b % a;
            }
            ++result;
        }
        if (result > 50)
            return false;
        cout << result << '\n';
        for (num i = 0; i < res.size(); ++i)
        {
            cout << int(res[i].first) + 1 << ' ' << res[i].second << '\n';
        }
        cout << s.str();
        return true;
    }
    if (a == 0 || b == 0)
    {
        cout << k << '\n';
        for (num i = 0; i < k; ++i)
        {
            cout << num(res[i].first) + 1 << ' ' << num(res[i].second) << '\n';
        }
        return true;
    }

    num new_a = 0, new_b = 0;
    for (num kk = -10; kk <= 10; ++kk)
    {
        if (kk == 0)
            continue;
        if (a + b * kk > 1000000000000000000 || a + b * kk < -1000000000000000000)
            continue;
        res[k] = { false, kk };
        if (recur(k + 1, a + kk * b, b))
            return true;
    }
    for (int kk = -10; kk <= 10; ++kk)
    {
        if (kk == 0)
            continue;
        if (b + a * kk > 1000000000000000000 || b + a * kk < -1000000000000000000)
            continue;
        res[k] = { true, kk };
        if (recur(k + 1, a, b + a * kk))
            return true;
    }
    return false;
}

int main() {
    ll aa, bb;
    cin >> aa >> bb;
    __int128 a = aa, b = bb;
    res.resize(MAX);
    if (!recur(0, a, b))
        throw(0);
    return 0;
}