﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <numeric>

typedef long long ll;

using namespace std;

int main() {
	std::vector<ll> fib(60);
	fib[0] = fib[1] = 1;
	for (ll i = 2; i < fib.size(); i++)
		fib[i] = fib[i - 1] + fib[i - 2];
	std::set<ll> fibset(fib.begin(), fib.end());

	ll a, b;
	cin >> a >> b;
	int result = 0;
	stringstream s;

	if (fibset.count(std::abs(a - b)) > 0)
	{
		s << "1 -2" << '\n';
		a -= 2*b;
	}

	while (a != 0 && b != 0)
	{
		if (abs(a) > abs(b))
		{
			s << "1 " << -(a / b) << '\n';
			a = a % b;
		}
		else
		{
			s << "2 " << -(b / a) << '\n';
			b = b % a;
		}
		++result;
	}

	cout << s.str();
	return 0;
}