#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <iomanip>
#include <cstdlib>
#include <fstream>
#include <ctime>
#include <random>

#define int long long

using namespace std;

const int INF = 1e18;
int n, a[200005], d[200005];
vector < int > edge[200005];

void bfs(int x)
{
    for(int i = 0; i < n; i++)
        d[i] = -INF;
    queue < int > q, qq;
    d[0] = ((x > a[0]) ? x : x / 2);
    q.push(0);
    while(q.size() || qq.size())
    {
        if(q.empty())
        {
            q = qq;
            while(qq.size())
                qq.pop();
        }
        int v = q.front();
        q.pop();
        for(auto to : edge[v])
        {
            if(d[v] > a[to] && d[v] > d[to])
            {
                d[to] = d[v];
                q.push(to);
            }
            if(d[v] / 2 > d[to])
            {
                d[to] = d[v] / 2;
                qq.push(to);
            }
        }
    }
}

main()
{
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
    int m;
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        edge[v].push_back(u);
        edge[u].push_back(v);
    }
    int x;
    cin >> x;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    bfs(x);
    cout << d[n - 1];
    return 0;
}
