#define _CRT_SECURE_NO_WARNINGS

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#/*kek, that works*/pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)3e5 + 5;
const ll mod = (ll)998244353;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

const ll mb = 60;

ll n;

ll a, b;

ll x[cst];

bitset<cst> used;

void clean(vector<ll>& v) {
    vector<ll> rt;
    for (ll& i : v) {
        if (rt.empty() || rt.back() != i) rt.push_back(i);
        else rt.pop_back();
    }
    v = rt;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n;
    for (ll i = 0; i < n; i++) {
        ll q;
        cin >> q;
        a ^= q;
        x[i] ^= q;
    }
    for (ll i = 0; i < n; i++) {
        ll q;
        cin >> q;
        b ^= q;
        x[i] ^= q;
    }
    ll answ = 0;
    for (ll bt = mb; bt >= 0; bt--) {
        if (((a ^ b) >> bt) & 1) {
            answ += (1ll << bt);
            a ^= a & (1ll << bt);
            b ^= b & (1ll << bt);
            for (ll i = 0; i < n; i++) x[i] ^= x[i] & (1ll << bt);
        }
    }
    vector<ll> basis(mb + 1, 0);
    vector<vector<ll>> basswap(mb + 1);
    for (ll i = 0; i < n; i++) {
        ll y = x[i];
        vector<ll> currsw;
        currsw.push_back(i);
        for (ll bt = mb; bt >= 0; bt--) {
            if ((y >> bt) & 1) {
                if (!basis[bt]) {
                    basis[bt] = y;
                    basswap[bt] = currsw;
                    break;
                }
                else {
                    y ^= basis[bt];
                    vector<ll> nv(basswap[bt].size() + currsw.size());
                    merge(all(basswap[bt]), all(currsw), nv.begin());
                    clean(nv);
                    swap(currsw, nv);
                }
            }
        }
    }
    for (ll bt = mb; bt >= 0; bt--) {
        if ((a >> bt) & 1) answ += (1ll << (bt + 1));
        else {
            a ^= basis[bt];
            for (ll& i : basswap[bt]) used[i].flip();
            if ((a >> bt) & 1) answ += (1ll << (bt + 1));
        }
    }
    cout << answ << " " << used.count() << endl;    
    for (ll i = 0; i < n; i++) {
        if (used[i]) cout << i + 1 << " ";
    }
    ex();
}



