#define _CRT_SECURE_NO_WARNINGS

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#/*kek, that works*/pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)3e5 + 5;
const ll mod = (ll)998244353;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll sgn(ll x) {
    if (x > 0) return 1;
    if (x < 0) return -1;
    return 0;
}

ll fib[105];

int main() {
    cin.tie(0)->sync_with_stdio(0);
    fib[0] = fib[1] = 1;
    for (ll i = 2; i <= 100; i++) {
        fib[i] = fib[i - 1] + fib[i - 2];
        if (fib[i] >= inf) {
           // cout << i << ") " << fib[i] << endl;
            break;
        }
    }
    ll a, b;
    a = fib[86], b = fib[85];
    cin >> a >> b;
    ll cpa = a, cpb = b;
    vector<pair<ll, ll>> answ;
    {
        ll sm = 2;
        while (a != 0 && b != 0) {
            if (abs(a) > abs(b)) {
                sm = (sm & 1) + 1;
                swap(a, b);
                continue;
            }
            ll x = abs(b) / abs(a);
            x *= -sgn(a) * sgn(b);
            b += a * x;
            answ.push_back({ sm, x });
            if (b != 0 && 0) {
                b += a * sgn(x);
                answ.back().second += sgn(x);
            }
        }
    }
    {
        vector<pair<ll, ll>> answ2;
        a = cpa;
        b = cpb;
        ll sm = 2;
        while (a != 0 && b != 0) {
            if (abs(a) > abs(b)) {
                sm = (sm & 1) + 1;
                swap(a, b);
                continue;
            }
            ll x = abs(b) / abs(a);
            x *= -sgn(a) * sgn(b);
            b += a * x;
            answ2.push_back({ sm, x });
            if (b != 0) {
                b += a * sgn(x);
                answ2.back().second += sgn(x);
            }
        }
        if (answ2.size() < answ.size()) answ = answ2;
    }
    cout << answ.size() << endl;
    for (auto i : answ) cout << i.first << " " << i.second << endl;
    ex();
}



