#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <map>
#define pb push_back
#define F first
#define S second
#define LL long long
#define Matrix vector <vector <long long>>

using namespace std;

void Ludociel(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL); cout.tie(NULL);
    #ifdef Kultivator
        //freopen("W.txt", "r", stdin);
    #endif // Kultivator
}

const int Mx = (int)1e6 + 7;
const int Md = (int)1e9 + 7;
const long long Inf = (long long)1e18 + 7;

map <LL, bool> Used;

bool Check(LL A){
    vector <LL> B;
    if(A % 10 == 0) return false;
    while(A > 0){
        LL Ew = (A % 10);
        B.pb(Ew);
        A /= 10;
    }
    //sort(B.begin(), B.end());
    long long Hp = false;
    for(int i = 0; i < B.size(); i++){
        //cout << B[i] << ' ';
        Hp += B[i];
        if(i < B.size() - 1) Hp *= 10LL;
    }
    //cout << Hp;
    LL t = sqrt(Hp);
    return (t * t == Hp);
}

int main(){
    Ludociel();
    LL A, B;
    cin >> A >> B;
    long long Ans = false;
    for(LL i = 1; i <= (LL)1e6; i++){
        LL Pw = (i * i);
        if(Check(Pw) && A <= Pw && Pw <= B){
            Ans++;
        }
    }
    cout << Ans << '\n';
    //Check(46456);
    //cout << Check(144) << '\n';
}
