#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif

    int n, m, k;
    cin >> n >> m >> k;

    if (min(n, m) < k) {
        cout << "Impossible" << '\n';
    }
    else {
        cout << "Possible" << '\n';
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < i; j++) {
                cout << '.';
            }
            cout << '*';
            for (int j = i + 1; j < m; j++) {
                cout << '.';
            }
            cout << '\n';
        }
        for (int i = k; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cout << '.';
            }
            cout << '\n';
        }
    }
}