#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    ll a, b;
    vector<pair<ll, ll>>ans;
    cin >> a >> b;
    while (a != 0 && b != 0)
    {
        if (abs(a) > abs(b))
        {
            ans.push_back({ 1, -a / b });
            a = a % b;
        }
        else
        {
            ans.push_back({ 2, -b / a });
            b = b % a;
        }
    }
    cout << ans.size() << "\n";
    for (auto i : ans)
    {
        cout << i.first << " " << i.second<<"\n";
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    while (t--) {
        solve();
    }
}