#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    return 0;
}

ll rev(ll a) {
    if (a % 10 == 0)
        return -1;
    ll ans = 0;
    while (a != 0) {
        ans = ans * 10 + a % 10;
        a /= 10;
    }
    return ans;
}

void solve() {
    ll a, b; cin >> a >> b;
    set<ll>sq;
    for (ll i = 1; i * i <= b; i++) {
        sq.insert(i * i);
    }
    int out = 0;
    for (ll i = 1; i * i <= b; i++) {
        if (i * i < a)
            continue;
        if (sq.find(rev(i * i)) != sq.end())
            out++;
    }
    cout << out;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}