#include <bits/stdc++.h>
//#include <bits/extc++.h>
//#include <tr2/dynamic_bitset>

#define int int64_t
#define double long double

using namespace std;
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
//
//template<typename T>
//using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//
//template<typename T>
//using ormset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int N = 1e4;
constexpr int mod = 1e9 + 7;

int bin_pow (int x, int y) {
    if (y == 0)
        return 1;
    if (y & 1)
        return bin_pow(x, y - 1) * x;
    int z = bin_pow(x, y>>1);
    return z * z;
}

int pow_mod (int x, int y) {
    if (y == 0)
        return 1;
    if (y & 1)
        return bin_pow(x, y - 1) * x % mod;
    int z = bin_pow(x, y>>1);
    return z * z % mod;
}

int divide(int x, int y) {
    return x * bin_pow(y, mod - 2) % mod;
}

void input () {

}

/*template<typename T>
T j_ans () {

}

template<typename T>
T p_ans () {

}

bool check () {
    return j_ans() == p_ans();
}*/

int x;
vector<vector<int> > g;
vector<int> cnt, d;

void dijkstra (int start) {
    d[start] = 0;
    if (x <= cnt[start])
        x /= 2;
    set<pair<int, int>> q;
    q.emplace(0, start);
    while (!q.empty()) {
        auto cur = *q.begin();
        int v = cur.second, dst = cur.first;
//        cout << v << ' ' << dst << '\n';
        q.erase(q.begin());
        if (dst > d[v])
            continue;
        for (auto u : g[v]) {
            int rem = x - dst;
            int luv;
            if (rem > cnt[u])
                luv = 0;
            else
                luv = rem - (rem>>1);
            if (rem - luv < 0 || d[v] + luv >= d[u])
                continue;
            d[u] = d[v] + luv;
            q.emplace(d[u], u);
        }
    }
}

int32_t main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<int>());
    while (m--) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cin >> x;
    cnt.assign(n, 0);
    d.assign(n, INT_MAX);
    for (auto &i: cnt)
        cin >> i;
    dijkstra(0);
//    for (int i = 0; i < n; i++)
//        cout << d[i] << ' ';
//    cout << '\n';
    cout << max(0LL, x - d[n - 1]);
}