#include <iostream>
#include <vector>
#include <iomanip>
#include <deque>

#define fr first
#define se second
#define ll int

using namespace std;

const ll N = 2 * 1e5;

vector< ll > G[N + 1];
vector< ll > a(N + 1);
vector<bool>used(N + 1, true);

int mx = -1,n;

void dfs(int pos, int x) {
    if(pos == n && x > mx) {
        mx = x;
    }
    if(!x) {
        return;

    }
    for(int i = 0; i < G[pos].size(); i++ ) {
        if(used[G[pos][i]]) {
            int t = x;
            if(t <= a[G[pos][i]]) {
                t /= 2;
            }
            used[G[pos][i]] = false;
            dfs(G[pos][i], t);
            used[G[pos][i]] = true;
        }
    }
}

main() {
    ll m;
    cin>>n>>m;

    for(int i = 0; i < m; i++) {
        int x,y;
        cin>>x>>y;
        G[x].push_back(y);
    }

    ll x;
    cin>>x;

    for(int i = 1; i <= n; i++) {
        cin>>a[i];
    }

    if(x <= a[1]) {
        x /= 2;
    }
    used[1] = false;
    dfs(1, x);
    cout<< (mx == -1 ? 0 : mx);
}
