#include <iostream>
#include <vector>
#include <iomanip>
#include <deque>

#define fr first
#define se second

using namespace std;

main() {
    int n,m;
    cin>>n>>m;

    vector< vector<int> > G(m + 1, vector<int>());

    for(int i = 0; i < m; i++) {
        int x,y;
        cin>>x>>y;
        G[x].push_back(y);
    }

    int x;
    cin>>x;

    vector< int > a(n + 1);
    for(int i = 1; i <= n; i++) {
        cin>>a[i];
    }

    vector< int > V(n +1, -1);
    deque <int> q;
    q.push_back(1);
    V[1] = (x > a[1] ? x : x / 2);
    while(!q.empty()) {
        int pos = q.front();
        q.pop_back();
        if(V[pos] != 0) {
            for(int i = 0; i < G[pos].size(); i++) {
                int t = V[pos];
                if(a[G[pos][i]] >= t) {
                    t /= 2;
                }
                if(V[G[pos][i]] < t) {
                    V[G[pos][i]] = t;
                    q.push_back(G[pos][i]);
                }
            }
        }
    }
    cout<<(V[n] != -1 ? V[n] : 0);
}
