#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define pf push_front
#define p_f pop_front
#define p_b pop_back
#define fi first
#define se second

using namespace std;

int rev(int n) {
    string N = to_string(n);
    reverse(N.begin(), N.end());
    return stoi(N);
}

int bin_pow(int a, int n) {
    int r = 1;
    while (n) {
        if (n & 1) {
            r *= r;
            --n;
        } else {
            r *= a;
            n >>= 1;
        }
    }
    return r;
}

void solve(){
    int a, b;
    cin >> a >> b;
    int c = 0;
    for (int i = a; i * i <= b; ++i) {
        if (i % 10 == 0) continue;
        int _12 = i; // 12
        int _12pow = (i * i); // 144
        int x = rev(_12pow); // 441
        int xsq = sqrt(x); // 21
        if (xsq * xsq != x) continue;

        int xsqRev = rev(xsq); // 12
        if (xsqRev == rev(i) || xsqRev == _12) {
            ++c;
        }
    }
    cout << c;
}

main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << '\n';
    }
}

