#define A
#ifdef A

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <fstream>
#include <deque>
#include <set>
#include <map>

using namespace std;

#define vec vector
#define int long long
#define pb push_back

const int inf = 2 * 1e18;
int n, m;
vec<vec<int>> gr;
vec<int>col;

signed main() {
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  //ofstream cout("cycle.out");
  //ifstream cin("cycle.in");
  cin >> n >> m;
  gr.resize(n);
  col.resize(n);
  for (int i = 0; i < n; ++i) {
    int u, v;
    cin >> u >> v;
    --u; --v;
    gr[u].pb(v);
    gr[v].pb(u);
  }
  int x;
  cin >> x;
  for (int i = 0; i < n; ++i) {
    cin >> col[i];
  }

  vec<int>used(n);
  set<pair<int, int>>d;
  vec<int>ost(n, -1);
  used[0] = true;
  //bool flag = (x <= col[0] ? 1 : 0);
  if (col[0] >= x)
    x /= 2;
  d.insert({ x, 0 });
  ost[0] = x;
  while (!d.empty()) {
    int cur = d.begin()->first;
    int v = d.begin()->second;
    d.erase(d.begin());
    for (auto u : gr[v]) {
      if (col[u] >= cur && (cur / 2) > ost[u]) {
        d.erase({ ost[u], u });
        ost[u] = cur / 2;
        d.insert({ cur >> 1, u });
      }
      else if (col[u] < cur && cur > ost[u]) {
        ost[u] = cur;
        d.erase({ ost[u], u });
        d.insert({ cur, u });
      }
    }
  }

  cout << ost[n - 1] << '\n';
}

#endif
