#include <bits/stdc++.h>
 
using namespace std;

bool isVowel(char c) {
	return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u';
}

int findSyllables(string s) {
	int ans = 0, last = 0;
	for(char c : s) {
		if(isVowel(c) && !last) {
			ans++;
		}
		last = isVowel(c);
	}
	return ans;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; i++) {
  		string s; cin >> s;
  		a[i] = findSyllables(s);
  	}
	
	int l = 0, sum = 0, ans = 0;
	for(int r = 0; r < n; r++) {
		sum += a[r];
		while (l < r && sum > 7) {
			sum -= a[l];
			l++;
		}
		if (sum == 7) {
			int leftSum = 0, rightSum = 0;
			for (int i = l - 1; i >= 0; i--) {
				leftSum += a[i];
				if(leftSum == 5) {
					leftSum = -1;
					break;
				} else if (leftSum > 5) {
				  break;
				}
			}
			for (int i = r + 1; i < n; i++) {
				rightSum += a[i];
				if (rightSum == 5) {
					rightSum = -1;
					break;
				} else if (rightSum > 5) {
				  break;
				}
			}
			if (leftSum == -1 && rightSum == -1) {
				ans++;
			}
		}
	}
	cout << ans;
	return 0;
}
