#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <queue>
#include <cmath>
#include <cstdlib>

#define fori(a, b) for(int i = a; i < b; ++i)
#define forj(a, b) for(int j = a; j < b; ++j)
#define fork(a, b) for(int k = a; k < b; ++k)
#define forn(n) for(int i = 0; i < n; ++i)
#define X first
#define Y second
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

void gcd(ll a, ll b, int &cnt) {
    if (a < b) swap(a, b);
    if (b == 0) return;
    cnt++;
    gcd(b, min(a % b, b - a % b), cnt);
}

void gcd2(ll a, ll b, ll as, ll bs) {
    if (a == 0 || b == 0) return;

    if (a > b) {
	if (a % b < b - a % b) {
	    cout << 1 << ' ' << -1 * as * bs * (a / b) << '\n';
	    a = a % b;
	} else {
	    cout << 1 << ' ' << -1 * as * bs * (a / b + 1) << '\n';
	    a = b - a % b;
	    as = as * (-1);
	}
    } else {
	if (b % a < a - b % a) {
	    cout << 2 << ' ' << -1 * as * bs * (b / a) << '\n';
	    b = b % a;
	} else {
	    cout << 2 << ' ' << -1 * as * bs * (b / a + 1) << '\n';
	    b = a - b % a;
	    bs = bs * (-1);
	}
    }

    gcd2(a, b, as, bs);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll a, b;
    cin >> a >> b;
    ll f1 = 0, f2 = 1, tmp = 0;
    forn(5){
      tmp = f2;
      f2 += f1, f1 = tmp;
    }
    int cnt = 0;
    gcd(f1, f2, cnt);
    cout << cnt << endl;
    gcd2(abs(f1), abs(f2), f1 > 0 ? 1 : -1, f2 > 0 ? 1 : -1);
    return 0;
}