#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unswitch-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

#include<bits/stdc++.h>

#define int long long
#define vec vector
#define sz(x) (int)(x.size())
#define f first
#define s second
#define pb push_back
#define endl "\n"
#define pii pair<int, int>
#define all(x) (x).begin(), (x).end()
#define rz resize
#define ld long double
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define rep(i, a, b) for(int i = a ; i < b ; i++)
#define Sum(a) accumulate(all(a), (int)0)
#define psum(a, b) partial_sum(a.begin(), a.end(), b.begin())
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define INF 2e18
#define inf 2e9
///#define int int_fast32_t

using namespace std;

/**

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

*/

template <class T>
istream& operator >> (istream &in, vector<T> &a)
{
    for(auto & i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector<T> &a)
{
    for(auto & i : a)
        out << i << ' ';
    return out;
}

template <class T, class U>
istream& operator >> (istream &in, pair<T, U> &a)
{
    in >> a.f >> a.s;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair<T, U> &a)
{
    out << a.f << ' ' << a.s << endl;
    return out;
}

mt19937 rnd(time(NULL));

#ifdef FelixDzerzhinsky
#define dbg(x) cout << (#x) << "\t" << (x) << endl
#else
#define dbg(x) 238
#endif

void files()
{
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
}

template<typename T1, typename T2>
inline T1 min(T1 a, T2 b)
{
    return (a < b ? a : b);
}

template<typename T1, typename T2>
inline T1 max(T1 a, T2 b)
{
    return (a > b ? a : b);
}

struct S{
    int s, v;
};

int f(int s1, int v1, int s2, int v2, int s3, int v3, int i, int j, int k, vector <pii>& ts){
    int A = (v1 - v2) * (k - j) - (v3 - v2) * (i - j), B = (s1 - s2) * (k - j) - (s3 - s2) * (i - j);
//    cout << i << ' ' << j << ' ' << k << ' ' << A <<  ' ' << B << endl;
    if(A == 0)return (B == 0);
    int p = -B, q = A;
    int g = __gcd(abs(A), abs(B));
    p /= g, q /= g;
    if(q < 0){
        p = -p;
        q = -q;
    }
    if(p < 0)return 0;
    ts.push_back({p, q});
    return 0;
}

ld const eps = 1e-9;

void solve()
{
    int n, ans = 2;
    cin >> n;
    vector <S> a(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].s >> a[i].v;
    }
    if(n == 1){
        cout << 1;
        return;
    }
    for(int i = 0; i < n; ++i){
        for(int j = i + 1; j < n; ++j){
            vector <pii> ts(0);
            int cnt = 0;
            for(int k = j + 1; k < n; ++k){
                if(i == k or j == k)
                    continue;
                cnt += f(a[i].s, a[i].v, a[j].s, a[j].v, a[k].s, a[k].v, i, j, k, ts);
            }
//            cout << i << ' ' << j << " : " << cnt << ' ' << ts.size() << endl;;
            int l = 0;
            sort(all(ts));
            ans = max(ans, cnt + 2);
            for(int k = 0; k < ts.size(); ++k){
                if(ts[l] != ts[k]){
                    l = k;
                }
                //else{
                    ans = max(ans, cnt + k - l + 3);
                //}
            }
        }
    }
    cout << ans;
}

signed main()
{
    //fast_io;
    #ifndef FelixDzerzhinsky
        fast_io
        //files
    #endif

    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}

/*
8
-4 1
1 1
2 1
5 1
8 1
21 1
26 1
31 1


3
1000000 20
9999980 40
9999979 41

*/

