#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x) * (x))

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n);
	vector<int> a(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int cnt;
	cin >> cnt;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<int> d(n, 0);
	set<pair<int, int>> s;
	if (a[0] >= cnt) {
		s.insert({ cnt / 2, 0 });
		d[0] = cnt;
	}
	else {
		s.insert({ cnt, 0 });
		d[1] = cnt;
	}
	while (!s.empty()) {
		auto tmp = *s.rbegin();
		s.erase(tmp);
		int v = tmp.second, c = tmp.first;
		for (auto u : g[v]) {
			int tmp_c = c;
			if (a[u] >= c) {
				tmp_c = c / 2;
			}
			if (d[u] < tmp_c) {
				d[u] = tmp_c;
				s.insert({ tmp_c, u });
			}
		}
	}
	cout << d[n - 1];
}


signed main() {
	ios::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	int t = 1;
	//	gen.seed(time(0));
	//	cout << fixed;
	//	cout.precision(15);
	//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
