#include <bits/stdc++.h>
#include <bits/extc++.h>

#define sz(v) int (v.size())
#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define int long long
#define pb push_back
#define all(a) a.begin(),a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; };
/// Actual code starts here
int n;
const int N = 100005;
const int L = 61;

void insert(ll x, int ind, vector<pair<ll, int>>& basis) {
    for (int i = L - 1; i >= 0; --i) {
        if (!((x >> i) & 1)) continue;
        if (basis[i].first == -1) {
            basis[i] = {x, ind};
            break;
        } else {
            x ^= basis[i].first;
        }
    }
}

vector<pair<ll, int>> get_basis(const vector<ll>& a) {
    vector<pair<ll, int>> b(L, {-1, -1});
    for (int i = 0; i < a.size(); ++i) {
        insert(a[i], i, b);
    }
    return b;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    ll xa = 0, xb = 0;
    for (int i = 0; i < n; ++i)
        cin >> a[i], xa ^= a[i];
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        xb ^= x;
        a[i] ^= x;
    }
    ll both = xa ^ xb ^ ((1LL << L) - 1);
    vector<ll> b(n);
    for (int i = 0; i < n; ++i)
        b[i] = a[i] & both;

    vector<pair<ll, int>> basis = get_basis(b);
    ll now = xa & xb;
    vector<int> res;
    for (int i = L - 1; i >= 0; --i) {
        if (basis[i].first == -1) {
            continue;
        } else {
            if ((now >> i) & 1) {
                continue;
            } else {
                now ^= basis[i].first;
                res.push_back(basis[i].second);
            }
        }
    }

    cout << (xa ^ xb) + 2 * now << ' ' << res.size() << '\n';
    for (int i : res)
        cout << i + 1 << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    freopen("input.txt", "r", stdin);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}