#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }

bool glasnaya(char c) {
    return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u';
}

int kek(string &s) {
    int ans = glasnaya(s[0]);
    for (int i = 1; i < s.size(); ++i) {
        if (glasnaya(s[i])) {
            ans += !glasnaya(s[i - 1]);
        }
    }

    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n;
    cin >> n;

    vector <string> s(n);
    vector <int> cnt(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        cnt[i] = kek(s[i]);
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int cur = 0;

        bool second = false, third = false;
        for (int j = i; j >= 0; --j) {
            cur += cnt[j];

            if (!third) {
                if (cur > 5) {
                    break;
                }
                else if (cur == 5) {
                    third = true;
                }

                continue;
            }
            else if (!second) {
                if (cur > 12) {
                    break;
                }
                else if (cur == 12) {
                    second = true;
                }

                continue;
            }
            else {
                if (cur > 17) {
                    break;
                }
                else if (cur == 17) {
                    ++ans;
                }

                continue;
            }
        }
    }

    cout << ans;

    return 0;
}