#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }

indexed_set<ll> p;

ll f(ll a) {
    if (p.find(a) == p.end())
        return p.order_of_key(a);
    else
        return p.order_of_key(a) + 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);


    for (ll i = 1; i <= 1e6; i++) {
        string s = to_string(i * i);
        reverse(all(s));
        if (s[0] == '0')
            continue;
        ll b = stoll(s);
        if ((ll)sqrt(b) * (ll)sqrt(b) == b) {
            p.insert(i * i);
            p.insert(b);
        }
    }


    ll a, b;
    cin >> a >> b;
    cout << f(b) - f(a - 1);

    return 0;
}