#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <deque>

const long long non = 1e10;

using namespace std;

int main()
{
    long long n;
    cin >> n;
    set<pair<long long, long long> > st;
    vector<long long> ans(n, non);
    for(long long i = 1; i <= n; i++){
        deque<long long> q;
        long long knon = 0, inon, sum = 0;
        for(long long j = 0; j <= n; j++){
            if(q.size() < i){
                q.push_back(ans[j]);
                if(ans[j] == non){
                    knon++;
                    inon = j;
                }
                else{
                    sum += ans[j];
                }
                continue;
            }
            //cout << "d " << j - i + 1 + 1 << " " << j + 1 << " " << knon << endl;

            if(knon == 1 && st.find({j - i, j - 1}) == st.end()){
                cout << "? " << j - i + 1 << " " << j << endl;
                long long s, l, r;
                cin >> s >> l >> r;
                l--; r--;
                ans[inon] = s - sum;
                q[q.end() - (n - j + 1) - 1] = s - sum;
                sum += s;
                knon--;
                st.insert({l, r});
                cout << "d " << l << " " << r << endl;
            }
            if(q.front() == non){
                knon--;
            }
            else{
                sum -= q.front();
            }
            q.pop_front();
        }
    }
    cout << "!" << endl;
    for(long long i = 0; i < ans.size(); i++)
        cout << ans[i] << " ";
    return 0;
}
