#include <algorithm>
#include <cmath>
#include <iostream>

using namespace std;
using ull = unsigned long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  ull a, b;
  cin >> a >> b;

  // floor - вниз, ceil - вверх
  ull lower = floor(sqrt(a));
  ull upper = ceil(sqrt(b));

  int ans = 0;
  for (ull i = lower; i <= upper; i++) {
    ull curr = i * i;
    if (curr < a || curr > b || curr % 10 == 0)
      continue;

    ull reversed = 0;
    while (curr > 0) {
      reversed = reversed * 10 + curr % 10;
      curr /= 10;
    }

    if (reversed < a || reversed > b || reversed % 10 == 0)
      continue;

    ull root = static_cast<ull>(sqrt(reversed));
    ans += (root * root == reversed);
  }

  cout << ans;
}
