﻿#include <iostream>
#include <map>
#include <vector>
#include <fstream>
#include <set>
#include <algorithm>
#include <iomanip>
#include <string>
#include <deque>
#include <math.h>
using namespace std;
#define int long long
typedef pair <int, int> ii;
typedef vector <int> vi;
typedef vector <ii> vii;
typedef vector<int> veci;
#define $ '\n'
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
inline void solve1();
inline void solve();
typedef long double ld;

template <class T> istream& operator >> (istream& is, vector<T>& x) {
	for (T& i : x) is >> i;
	return is;
}
template <class T> ostream& operator << (ostream& o, const vector<T>& x) {
	for (T e : x) o << e << ' ';
	return o;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	solve();
	cout.flush();

	return 0;
}

int gcd(int a, int b) {
	if (a == 0) return b;
	return gcd(a % b, a);
}

inline void solve() {
	int n; cin >> n;
	veci s(n), v(n);
	for (int i = 0; i < n; i++) {
		cin >> s[i] >> v[i];
	}
	if (n == 1) {
		cout << 1 << $;
		return;
	}

	int ans = 0;

	for (int a = 0; a < n; a++)
		for (int b = 0; b < a; b++) {
			if (a == b) continue;
			map<pair<int, int>, int> x;
			for (int i = 0; i < n; i++) {
				if (i == a || i == b) continue;
				int u = (s[a] - s[i]) * (b - i) - (s[b] - s[i]) * (a - i);
				int d = (v[b] - v[i]) * (a - i) - (v[a] - v[i]) * (b - i);
//				cerr << a << " " << b << " " << i << ": " << u << ", " << d << " -> " << ld(u) / d << $;

				if (u == 0 && d == 0) {
					x[{u, d}]++;

					ans = max(ans, x[{u, d}]);
					continue;
				}

				if (d == 0) continue;
				if (d < 0) {
					u *= -1;
					d *= -1;
				}
				if (u < 0) continue;
				int g = gcd(u, d);
				u /= g; d /= g;

				x[{u, d}]++;

				ans = max(ans, x[{u, d}]);
			}
		}
	cout << ans + 2 << $;
}