#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

int depth = 0;
int cur = 0;


void solve() {
    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> arr(m + 1);
    vector<int> len(m + 1);
    for (int i = 1; i <= m; ++i) {
        cin >> arr[i].x >> arr[i].y;
        len[i] = arr[i].y - arr[i].x + 1;
    }

    vector<vector<int>> dp(n + 1, vector<int> (m + 1, INF));

    for (int row = 1; row <= n; ++row)
        dp[row][0] = 0;

    for (int i = 1; i <= m; ++i) {

        multiset<int> s;

        vector<int> dp_mem(n + 1, INF);

        for (int j = 1; j <= n; ++j) {
            s.insert(dp[j][i - 1]);
            if (s.size() < len[i])
                continue;
            if (s.size() > len[i])
              s.erase(s.find(dp[j - len[i]][i - 1]));

            if (*s.begin() >= INF)
                continue;
            dp_mem[j] = *s.begin() + abs(j - arr[i].y);
        }

        s.clear();

        for (int j = n; j >= 1; --j) {
            s.insert(dp_mem[j]);
            if (s.size() < len[i])
                continue;
            if (s.size() > len[i])
              s.erase(s.find(dp_mem[j + len[i]]));
            dp[j][i] = *s.begin();
        }
    }


    int ans = INF;
    for (int i = 1; i <= n; ++i)
        ans = min(ans, dp[i][m]);

    cout << ans << endl;
}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    cout.precision(16);

    solve();
}
