#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define double ld

using namespace std;

const int inf = 1e9;
const ll INF = 1e18;

const int maxn = 1e5;

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (auto & e : a)
        cin >> e;
    for (auto & e : b)
        cin >> e;
    bitset<maxn> swapped;
    mt19937 rnd;

    ll xa = 0, xb = 0;

    for (auto & e : a)
        xa ^= e;
    for (auto & e : b)
        xb ^= e;

    vector<ll> diff(n);
    for (int i = 0; i < n; ++i)
        diff[i] = (a[i] ^ b[i]);

    for (int _ = 0; _ < 5e7; ++_) {
        int x = rnd() % n;

        if (((xa ^ diff[x]) + (xb ^ diff[x])) >= xa + xb) {
            swapped[x] = !swapped[x];
            xa = xa ^ diff[x];
            xb = xb ^ diff[x];
        }
    }

    cout << xa + xb << " " << swapped.count() << endl;
    for (int i = 0; i < n; ++i)
        if (swapped[i])
            cout << i + 1 << " ";
    cout << endl;

}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    cout.precision(16);

    solve();
}
