#if 1


#define DEBUG 0

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

#if DEBUG
int runs = 1;
ifstream input("ProblemI/in.txt");
ofstream output("ProblemI/out.txt");
#else
int runs = 1;
istream& input = std::cin;
ostream& output = std::cout;
#endif

typedef long long ll;


ll reverseNum(ll num, vector<ll> &tenPow)
{
	ll res = 0;

	ll cur = 11;
	ll cur2 = 0;
	bool flag = false;
	while (cur != -1)
	{
		ll d = (num % tenPow[cur + 2]) / tenPow[cur--];

		if (d != 0)
			flag = true;

		if (flag)
			res += d * tenPow[cur2++];
	}

	return res;
}

int main()
{
	while (runs-- > 0)
	{
		vector<ll> tenPow(14);

		tenPow[0] = 1;
		for (int i = 1; i < 14; i++)
		{
			tenPow[i] = tenPow[i - 1] * 10;
		}

		ll A, B;

		input >> A >> B;
		/*
		for (int i = 1; i < 1000; i++)
			output << i << " " << reverseNum(i, tenPow) << "\n";*/


		int ans = 0;
		for (ll i = sqrt(A); i < sqrt(B) + 1; i++)
		{
			if (i % 10 == 0)
				continue;
			ll num = reverseNum(i * i, tenPow);
			if (sqrt((double)num) == (ll)sqrt(num))
				ans++;
		}
		output << ans << "\n";
	}
	return 0;
}

#endif
