vowels = set(["a", "e", "i", "o", "u"])

def phonetic_units_count(s):
    cnt = 0
    prev_is_vowel = s[0] in vowels
    for i in range(1, len(s)):
        cur_is_vowel = s[i] in vowels
        if (prev_is_vowel and not cur_is_vowel):
            cnt += 1
        prev_is_vowel = cur_is_vowel
    return (cnt + prev_is_vowel)

n = int(input())
L = [(phonetic_units_count(str(input()))) for _ in range(n)]
cnt = 0
i1, i2, i3, i4 = -1, -1, -1, -1
sum1, sum2, sum3 = 0, 0, 0

while (i4 + 1 < n):
    is_haiku = sum1 == 5 and sum2 == 7 and sum3 == 5
    cnt += is_haiku

    if (i1 + 1 < n and (sum1 < 5 or is_haiku)):
        i1 += 1
        sum1 += L[i1]
    elif (i2 + 1 < n and (sum1 > 5 or sum2 < 7 or is_haiku)):
        i2 += 1
        sum1 -= L[i2]
        sum2 += L[i2]
    elif (i3 + 1 < n and (sum2 > 7 or sum3 < 5 or is_haiku)):
        i3 += 1
        sum2 -= L[i3]
        sum3 += L[i3]
    elif (sum3 > 5 or is_haiku):
        i4 += 1
        sum3 -= L[i4]
    else:
        break

print(cnt)
