#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 1e5 + 10, oo = 1e9 + 10, LOG = 61;
ll base[LOG], ban[LOG], reversed = -1;
bitset<N> subset[LOG];
void insert(ll x, ll index) {
   x &= reversed;
   vector<int> indices;
   for (int bit = LOG - 1; bit >= 0; --bit) {
      if (x >> bit & 1) {
         if (base[bit] == 0) {
            subset[bit][index] = 1;
            base[bit] = x;
            for (int id : indices) {
               subset[bit] ^= subset[id];
            }
            return;
         }
         x ^= base[bit];
         indices.push_back(bit);
      }
   }
   assert(x == 0);
}
bitset<N> get_max(ll z) {
   bitset<N> answer;
   for (int bit = LOG - 1; bit >= 0; --bit) {
      if (z < (z ^ base[bit])) {
         z ^= base[bit];
         answer ^= subset[bit];
      }
   }
   return answer;
}
int main() {
   ios::sync_with_stdio(0); cin.tie(0);
   ll n, x = 0, y = 0;
   cin >> n;
   vector<ll> a(n), b(n);
   for (int i = 0; i < n; ++i) {
      cin >> a[i];
      x ^= a[i];
   }
   for (int i = 0; i < n; ++i) {
      cin >> b[i];
      y ^= b[i];
   }
   ll z = 0;
   for (int bit = LOG - 1; bit >= 0; --bit) {
      if ((x ^ y) >> bit & 1) {
         reversed ^= 1LL << bit;
      } else {
         z += 1LL * (x >> bit & 1) << bit;
      }
   }
   vector<ll> s(n);
   for (int i = 0; i < n; ++i) {
      s[i] = a[i] ^ b[i];
      insert(s[i], i);
   }
   auto answer = get_max(z);
   ll to = 0;
   for (int i = 0; i < N; ++i) {
      if (answer[i] == 1) {
         to ^= s[i];
      }
   }
   cout << (x ^ to) + (y ^ to) << ' ' << answer.count() << endl;
   for (int i = 0; i < N; ++i) {
      if (answer[i] == 1) {
         cout << i + 1 << ' ';
      }
   }
}
