#define _CRT_SECURE_NO_WARNINGS

#ifndef _DEBUG
#include<bits/stdc++.h>
#endif

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <deque>

typedef long long ll;
#define endl '\n'
#define mp make_pair
#define pb push_back

using namespace std;

using ld = long double;

const int N = 2e6, INF = 1e9;
const int X = (1 << 20);

int st[2 * X];
int a[N];
int n;

int get(int i, int l, int r, int l0, int r0)
{
	if (l >= r0 || l0 >= r)
		return INF;
	if (l0 <= l && r <= r0)
		return st[i];
	int m = (l + r) / 2;
	int res1 = get(i * 2 + 1, l, m, l0, r0);
	int res2 = get(i * 2 + 2, m, r, l0, r0);
	return min(res1, res2);
}

void build_st()
{
	for (int i = 0; i < n; i++)
	{
		st[X - 1 + i] = a[i];
	}
	for (int i = X - 1 + n; i < 2 * X - 1; i++)
	{
		st[i] = INF;
	}
	for (int i = X - 2; i >= 0; i--)
	{
		st[i] = min(st[i * 2 + 1], st[i * 2 + 2]);
	}
}

bool used[N];
int s[N], t[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int m;
	cin >> n >> m;
	for (int i = 0; i < m; i++)
	{
		cin >> s[i] >> t[i];
		s[i]--;
		t[i]--;
	}
	for (int i = 0; i < m; i++)
	{
		build_st();
		int sz = t[i] + 1 - s[i];
		for (int j = 0; j < n; j++)
		{
			if (j + sz > n)
			{
				a[j] = INF;
				continue;
			}
			int sz1 = 0;
			if (i != 0)
				sz1 = t[i - 1] - s[i - 1] + 1;
			int l = max(0, j - sz1 + 1), r = j + sz1;
			int res = get(0, 0, X, l, r);
			if (i == 0)
				res = 0;
			a[j] = res + abs(j - s[i]);
		}
	}
	int ans = INF;
	for (int i = 0; i < n; i++)
	{
		ans = min(ans, a[i]);
	}
	cout << ans;
}