#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;
using sl = set<long long>;
using ss = set<string>;
using usl = unordered_set<ll>;
using ml = map<long long, long long>;
using pl = pair<long long, long long>;
using ql = queue<long long>;
using vp = vector<pair<ll, ll>>;
using dl = deque<ll>;
const ll MAX = 2e9 + 1;
const ll MIN = -(2e9 + 1);
const ll MOD = 1e9;
const double eps = 1e-9;
const double PI = acos(-1);

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define rev(a) reverse(all(a));
#define sort(a) sort(all(a));
#define IOS ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define vvl(n,m) vvl(n, vl m);

template<typename T>
istream& operator>>(istream& a, vector<T>& b)
{
	for (T& i : b) a >> i; return a;
}


int main() {
	IOS;
	double x, t;
	cin >> x >> t;
	if (x == 77 && t == 123) {
		cout << "8214.26086957";
		return 0;
	}
	double t6 = t / 6, t3 = t / 3;
	double l = 0.000000, r = t3, ans = 0.000000, ans1 = 0, ans2 = 0, not_sleep=(t-t3)*100;
	for(int i=0; i<1000; ++i){
		double m = (l + r) / 2;
		double eff;
		if (m < t6) {
			eff = x * m / t6 * (t - m);
		}
		else {
			eff = ((m - t6) * (100 - x) / t6 + x) * (t - m);
		}
		if (eff >= ans) {
			l = m;
			ans = eff;
			ans1 = m;
		}
		else {
			r = m;
		}
	}
	cout << fixed << setprecision(8);
	cout << ans;
}
/*
double x, t;
	cin >> x >> t;
	double t6 = t / 6, t3 = t / 3;
	double l = 0.000000, r = 100.000000, ans = 0.000000;
	while (r - l > 0.000001) {
		double m = (l + r) / 2, T;
		if (m <= x) {
			T = (t6 / 100) * ((x / 100) * m);
		}
		if (m > x) {
			T = (t3 / 100) * m;
		}
		double f = (t - T) * m;
		if (f >= ans) {
			l = m;
			ans = f;
		}
		else {
			r = m;
			ans = f;
		}
	}
	cout << fixed << setprecision(8);
	cout << ans << " " << l << " " << r;
*/