#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

struct aboba{
    int x,y,ind;
};

bool comp(aboba a, aboba b){
    int d1 = a.x - a.y;
    int d2 = b.x - b.y;
    if(d1 < d2)
        return true;
    else
        return false;

}
inline void solve() noexcept {
    int n, a,b;
    cin >> n >> a >> b;
    vector <aboba> v(n);
    int ans = 0;
    int cnt_a = n, cnt_b = 0;
    vector <char> p(n);
    for (int i = 0; i < n; ++i){
        cin >> v[i].x;
        v[i].ind = i;
        ans+=v[i].x;
        p[i] = 'T';
    }
    for (int i = 0; i < n; ++i){
        cin >> v[i].y;
    }
    sort(v.begin(), v.end(), comp);
    for (int i = 0; i < n; ++i){
        if(cnt_b < b){
            ans-= v[i].x;
            ans+= v[i].y;
            p[v[i].ind] = 'P';
            cnt_a--; cnt_b++;
        }else{
            if(cnt_a > a && v[i].y > v[i].x){
                p[v[i].ind] = 'P';
                cnt_a--;cnt_b++;
                ans -= v[i].x;
                ans += v[i].y;
            }
            else
                break;
        }
    }
    //cout << sz(p) << endl;
    cout << ans << '\n';
    for (auto i : p){
        cout << i << " ";
    }
    cout << endl;
    return;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio();
    int tt = 1;
    //cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
