﻿/*#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n, m, x;

    cin >> n >> m;

    vector<vector<pair<ll, ll>>> v(n);

    for (int i = 0; i < m; i++) {
        ll from, to;
        cin >> from >> to;
        from--; to--;
        v[from].push_back({ to, 0 });
        v[to].push_back({ from, 0 });
    }
    cin >> x;
    for (int i = 0; i < n; i++) {
        cin >> v[i][0].second;
    }
}*/

#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

ll change(ll num) {
    string s;
    ll ans;
    s = to_string(num);
    reverse(s.begin(), s.end());
    if (s[0] == '0') return -1;
    ans = stoi(s);
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll a, b;

    cin >> a >> b;

    set<ll> sett;

    for (ll i = a; i <= b; i++) {
        if (find(sett.begin(), sett.end(), i) != sett.end()) continue;
        ll num = i;
        double temp;
        temp = sqrt(num);
        if (temp != (int)temp) continue;
        double tmp;
        ll g;
        g = change(num);
        if (g == -1) continue;
        tmp = sqrt(g);
        if (tmp != (int)tmp) continue;
        sett.insert(num);
        if (g <= b) {
            sett.insert(g);
        }
    }
    //for (auto i : sett) cout << i << ' ' << "\n";
    cout << sett.size();
}