﻿/*#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

const ll INF = 1e18;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n, m, x;

    cin >> n >> m;

    vector<vector<pair<ll, ll>>> v(n);

    for (int i = 0; i < m; i++) {
        ll from, to;
        cin >> from >> to;
        from--; to--;
        v[from].push_back({ to, 0 });
        v[to].push_back({ from, 0 });
    }
    cin >> x;
    for (int i = 0; i < n; i++) {
        ll y;
        cin >> y;
        v[i][0].second = y;
        v[v[i][0].first][0].second = y;
    }
    vector<ll> dp(n,INF);
    vector<ll> pred(n);

    dp[0] == 0;
    set<pair<ll, ll>> q;
    q.insert({ dp[0], 0 });
    while (!q.empty()) {
        ll p = q.begin()->second;
        q.erase(q.begin());
        for (int j = 0; j < v[p].size(); j++) {
            ll to = v[p][j].first, cost = v[p][j].second;
            if (dp[p] + cost < dp[to]) {
                q.erase({ dp[to], to });
                dp[to] = dp[p] + cost;
                pred[to] = p;
                q.insert({ dp[to], to });
            }
        }
    }
}*/

#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
/*#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

ll change(ll num) {
    string s;
    ll ans;
    s = to_string(num);
    reverse(s.begin(), s.end());
    if (s[0] == '0') return -1;
    ans = stoi(s);
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll a, b;

    cin >> a >> b;

    set<ll> sett;

    for (ll i = a; i <= b; i++) {
        if (find(sett.begin(), sett.end(), i) != sett.end()) continue;
        ll num = i;
        double temp;
        temp = sqrt(num);
        if (temp != (int)temp) continue;
        double tmp;
        ll g;
        g = change(num);
        if (g == -1) continue;
        tmp = sqrt(g);
        if (tmp != (int)tmp) continue;
        sett.insert(num);
        if (g <= b && g >= a) {
            sett.insert(g);
        }
    }
    //for (auto i : sett) cout << i << ' ' << "\n";
    cout << sett.size();
}*/

#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

ll change(ll num) {
    string s;
    ll ans;
    s = to_string(num);
    reverse(s.begin(), s.end());
    if (s[0] == '0') return -1;
    ans = stoi(s);
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll a, b;

    cin >> a >> b;

    set<ll> sett;

    double sq = sqrt(a);

    ll left, right;

    if (sq != (int)sq) {
        left = (ll)sq + 1;
    }
    else left = (ll)sq;

    ll k = 0;

    while (left * left <= b) {
        if (left % 10 == 0) {
            left++;
            continue;
        }
        double tmp;
        ll g;
        g = change(left * left);
        if (g == -1) {
            left++;
            continue;
        }
        tmp = sqrt(g);
        if (tmp != (int)tmp) {
            left++;
            continue;
        }
        k++; left++;
    }
    cout << k;
}