#include <iostream>
#include <deque>
#include <utility>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
using namespace std;

struct line
{
    long double k, b;
};

long double get(line a, long double x)
{
    return a.k * x + a.b;
}

long double cross(line a, line b, int& ok)
{
    if(a. k == b.k && b.b == a.b)
    {
        ok = 2;
        return 0.0;
    }
    if(a.k == b.k )
    {
        ok = 0;
        return 0.0;
    }
    ok = 1;
    return (b.b - a.b) / (a.k - b.k);
}

int main() 
{
    int n, answer = 0; cin>>n;
    vector<pair<long double, long double> > arr(n);
    for(int i = 0; i < n; i++) cin>>arr[i].first>>arr[i].second;
    for(int i = 0; i < n; i++)
    {
        int bias = 0;
        map<pair<long double, long double>, int> ans;
        vector<line> tmp;
        for(int j = 0; j < n; j++)
            if(i != j)
                tmp.push_back({(arr[i].second - arr[j].second) / (long double)(j - i), (arr[i].first - arr[j].first) / (long double)(j - i)});
        for(int k = 0; k < n - 1; k++)
        {
            for(int j = 0; j < n - 1; j++)
            {
                if(k != j)
                {   
                    int ok; 
                    long double t = cross(tmp[k], tmp[j], ok);
                    if(ok == 1)  ans[{t, get(tmp[k], t)}]++;                   
                    else if(ok == 2) bias++;
                }
            }   
        }
        for(auto i: ans) answer = max(answer, bias + 1 + (int)((1 + sqrt(1 + 8 * i.second)) / 2));
    }
    cout<<answer;
    return 0;
}