#include <iostream>
#include <algorithm>

const long long maxN = 200000;
bool ans[maxN];
long long n, a, b, x[maxN], y[maxN], temp;
std::pair<long long, long long> c[maxN];

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n >> a >> b;
    for (long long i = 0; i < n; i++)
        std::cin >> x[i];
    for (long long i = 0; i < n; i++) {
        std::cin >> y[i];
        c[i] = { y[i] - x[i], i };
    }
    std::sort(c, c + n);
    for (long long i = 0; i < a; i++)
        ans[c[i].second] = true;
    for (long long i = n - 1, j = 0; j < b; i--, j++)
        ans[c[i].second] = false;
    for (long long i = a; i < n - b; i++)
        ans[c[i].second] = c[i].first < 0;
    for (long long i = 0; i < n; i++) {
        if (ans[i])
            temp += x[i];
        else
            temp += y[i];
    }
    std::cout << temp << "\n";
    for (long long i = 0; i < n; i++)
        std::cout << (ans[i] ? "T " : "P ");
    return 0;
}