﻿#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <functional>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <array>
#include <random>
#include <chrono>

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
using namespace std;
using namespace std::chrono;

#define all(x) x.begin(), x.end()
//#define int long long

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
}

const int N = 2e5 + 1;
const int INF = 2e9;

void solve() {
	int n, m; cin >> n >> m;
	vector<pair<int, int>> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i].first >> a[i].second;
	}
	sort(all(a));
	vector<pair<int, int>> new_a;
	int l = a[0].first, r = a[0].second;
	for (int i = 1; i < m; i++) {
		if (a[i].first <= r) {
			r = a[i].second;
		}
		else {
			new_a.push_back({ l, r });
			l = a[i].first, r = a[i].second;
		}
	}
	new_a.push_back({ l, r });
	int sz = int(new_a.size());
	vector<int> pos = { sz / 2, sz - sz/2 };
	int ans = INF;
	for (auto p : pos) {
		int sum = 0;
		for (int i = 0; i < sz; i++) {
			if (i == p) continue;
			if (i < p) sum += a[p].first - a[i].second;
			else sum += a[i].first - a[p].second;
		}
		ans = min(sum, ans);
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	//freopen("game.in", "r", stdin);
	//freopen("game.out", "w", stdout);
	int _t = 1; //cin >> _t;
	while (_t--) {
		solve();
		//gen();
	}
}