#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <cmath>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	int n;
	cin >> n;
	vector <int> lst;
	string q;
	for (int _ = 0; _ < n; _++) {
		cin >> q;
		int cnt = 0;
		bool flag = false;
		for (auto x : q) {
			if (x == 'a' || x == 'e' || x == 'i' || x == 'o' || x == 'u') {
				flag = true;
			} else {
				if (flag) {
					cnt++;
				}
				flag = false;
			}
		}
		if (q.back() == 'a' || q.back() == 'e' || q.back() == 'i' || q.back() == 'o' || q.back() == 'u') {
			cnt++;
		}
		lst.push_back(cnt);
	}
	int ans = 0;
	vector<int> p = { 0 };
	for (int _ = 0; _ < n; _++) {
		p.push_back(p[p.size() - 1] + lst[_]);
	}
	map<int, map<int, int>> haikus;
	for (int l = 0; l <= n; l++) {
		for (int r = l; r <= n; r++) {
			if (p[r] - p[l] == 5) {
				haikus[r] = map<int, int>();
			}
		}
	}
	for (auto &l : haikus) {
		for (int r = l.first; r <= n; r++) {
			if (p[r] - p[l.first] == 7) {
				l.second[r] = 0;
			}
		}
	}
	for (auto& _ : haikus) {
		for (auto& l : _.second) {
			for (int r = l.first; r <= n; r++) {
				if (p[r] - p[l.first] == 5) {
					ans++;
				}
			}
		}
	}
	cout << ans;
	return 0;
}