#include <bits/stdc++.h>

using namespace std;
#define int __int128
using u64 = unsigned long long;
using s64 = long long;
using u32 = unsigned int;
using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int> >;
using pii = pair<int, int>;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define all(a) (a).begin(), (a).end()

int greedy(int a, int b, int cnt = 0) {
    if (b == 0) return cnt;
    return greedy(b, a - (a/b) * b, cnt+1);
}

void solve(istream& cin, ostream& cout) {
    int32_t A, B;
    cin >> A >> B;
    map<pii, tuple<int, int, int, int> > par;
    map<pii, int> dp;
    set<tuple<int, int, pii> > q;
    if (A > B) {
        par[{A, B}] = {-1, -1, -1, -1};
        dp[{A, B}] = 0;
        q.insert({0, 0, {A, B}});
    } else {
        par[{B, A}] = {-1, -1, -1, -1};
        dp[{B, A}] = 0;
        q.insert({0, 1, {B, A}});
        swap(A, B);
    }
    while (!q.empty()) {
        int cost, type; pii cur; tie(cost, type, cur) = *q.begin(); q.erase(q.begin());
        int a, b; tie(a, b) = cur;
        if (cur.second == 0) {
            vector<pair<int32_t, int32_t> > ans;
            while (cur.first != A || cur.second != B) {
                int na, nb, ntype, nk;
                tie(na, nb, ntype, nk) = par[cur];
                cur = {na, nb};
                ans.emplace_back(ntype, nk);
            }
            reverse(all(ans));
            cout << ans.size() << '\n';
            for (auto& x : ans) cout << x.first + 1 << ' ' << x.second << '\n';
            return;
        }
        int k = -a/b;
        // + 0
        if (!par.count({b, a+k*b})) {
            par[{b, a+k*b}] = {a, b, type, k};
            dp[{b, a+k*b}] = dp[{a, b}] + 1;
            q.insert({dp[{b, a+k*b}] + greedy(b, a+k*b)/3, 1-type, {b, a+k*b}});
        }
        // + 1
        k++;
        if (!par.count({b, a+k*b})) {
            par[{b, a+k*b}] = {a, b, type, k};
            dp[{b, a+k*b}] = dp[{a, b}] + 1;
            q.insert({dp[{b, a+k*b}] + greedy(b, a+k*b)/3, 1-type, {b, a+k*b}});
        }
        k--;
        // - 1
        k--;
        if (!par.count({b, a+k*b})) {
            par[{b, a+k*b}] = {a, b, type, k};
            dp[{b, a+k*b}] = dp[{a, b}] + 1;
            q.insert({dp[{b, a+k*b}] + greedy(b, a+k*b)/3, 1-type, {b, a+k*b}});
        }
        k++;
    }
}


int32_t main(){
    //ifstream cin("in.txt");
    //ofstream cout("out.txt");
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve(cin, cout);
    }
    return 0;
}
