//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>


//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& i : a) {
        out << a;
    }
    return out;
}

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))
int n, m;
vector<vector<int>> gr;


void solve(){
    cin >> n >> m;
    int s = 0;
    int f = n - 1;
    gr.assign(n, {});
    int u, v;
    for (int i = 0; i < m; i++){
        cin >> u >> v;
        gr[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }
    int S = 0;
    cin >> S;
    vector<int> enems(n);
    for (int i = 0; i < n; i++){
        cin >> enems[i];
    }
    priority_queue<pair<int, int>, vector<pair<int, int>>, less<pair<int, int>>> q;
    S = S >= enems[0] ? S : S / 2;
    q.push({S, 0});
    vector<int> dp(n, 0);
    dp[0] = S;
    vector<int> used;
    used.assign(n, 0);
    while (!q.empty()){
        auto [l, v] = q.top();
        q.pop();
        used[v] = 1;
        for (auto &u: gr[v]){
            if (!used[u]){
                if (enems[u] >= dp[v]){
                    if (dp[u] < dp[v] / 2){
                        dp[u] = dp[v] / 2;
                        q.push({dp[u], u});
                    }
                }
                else{
                    if (dp[u] < dp[v]){
                        dp[u] = dp[v];
                        q.push({dp[u], u});
                    }
                }
            }
        }
    }
    cout << dp[n - 1] << "\n";
    return;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    solve();
    return 0;
}
