#include "bits/stdc++.h"
#define fori for (int i = 0; i < n; ++i)
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#ifdef qwe
bool debug = true;
#else
bool debug = false;
#endif

const int INF = 1e9 + 228;


inline void solve() {
	int n,m ;
	cin >> n >> m;

	int u, v;
	vector <vector <int>> graph(n);
	for (int i = 0; i < m; i++) {
		cin >> u >> v;
		// cout << u << ' ' << v << '\n';
		u--; v--;
		graph[u].emplace_back(v);
		graph[v].emplace_back(u);
	}


	vector <int> gayfuck(n, -INF);

	int x;
	cin >> x;

	vector <int> a(n);
	for (int &x: a) cin >> x;

	gayfuck[0] = x > a[0] ? x : (x / 2);

	set <pair <int, int>> q;
	q.emplace(-gayfuck[0], 0);

	while (!q.empty()) {
		auto [sex, u] = *q.begin();
		q.erase(q.begin());

		int gay = -sex;

		for (int v: graph[u]) {
			int new_gay = gay > a[v] ? gay : (gay / 2);
			if (new_gay > gayfuck[v]) {
				q.erase({-gayfuck[v], v});
				gayfuck[v] = new_gay;
				q.emplace(-new_gay, v);
			}
		}
	}

	cout << gayfuck[n - 1] << '\n';
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	solve();
}

