#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int x, y;
	cin >> x >> y;
	vector<pair<int, ll>> ans;
	if (max(x, y) < 0) {
		while (x != 0 && y != 0) {
			if (x < y) {
				ll k = -x/y;
				x += k*y;
				ans.pb({1, k});
			} else {
				ll k = -y/x;
				y += k*x;
				ans.pb({2, k});				
			}
		}
		cout << ans.size() << '\n';
		for (auto [t, k] : ans) cout << t << ' ' << k << '\n';
		exit(false);
	}
	if (min(x, y) < 0) {
	 	while (x != 0 && y != 0) {
	 		if (abs(x) > abs(y)) {
	 			ll k = -x/y;
	 			x += k*y;
	 			ans.pb({1, k});
	 		} else {
	 			ll k = -y/x;
	 			y += k*x;
	 			ans.pb({2, k});
	 		}
	 	}
		cout << ans.size() << '\n';
		for (auto [t, k] : ans) cout << t << ' ' << k << '\n';
		exit(false);
	}
	while (x != 0 && y != 0) {
		if (x > y) {
			ll k = -x/y;
			x += k*y;
			ans.pb({1, k});		
		} else {
			ll k = -y/x;
			y += k*x;
			ans.pb({2, k});
		}
	}	
	cout << ans.size() << '\n';
	for (auto [t, k] : ans) cout << t << ' ' << k << '\n';
	return 0;
}