/// adil sultanov | vonat1us 

#pragma GCC optimize("O3")
//#pragma comment(linker, "/STACK:36777216")

#include<bits/stdc++.h>

#define x first
#define y second
#define pb push_back
#define sz(x) (int) x.size()
#define all(z) (z).begin(), (z).end()
 
using namespace std;

using ll = long long;
using pii = pair<int, int>;                                   

const int MOD = 1e9 + 7; 
const int INF = 1e9 + 1e2;
  
void fin() {
#ifdef AM
    freopen(".in", "r", stdin);
#endif        
}                   

const bool flag = 0;

const int N = 2e5+10;

int e[N], d[N];

vector<int> adj[N];

void dijkstra(int ws) {
    priority_queue<pii> q;
    q.push({ws, 0});
    fill(d, d+N, -INF);
    d[0] = ws;
    while (!q.empty()) {
        int x = q.top().y;
        int w = q.top().x;
        q.pop();
        if (d[x] != w) {
            continue;
        }
        for (int to : adj[x]) {
            int nw = w;
            if (e[to] >= w) {
                nw /= 2;
            }
            if (d[to] < nw) {
                d[to] = nw;
                q.push({nw, to});
            }
        }
    }
}

void ma1n() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        adj[u].pb(v);
        adj[v].pb(u);
    }
    int x;
    cin >> x;
    for (int i = 0; i < n; ++i) {
        cin >> e[i];
    }
    if (e[0] >= x) {
        x >>= 1;
    }
    dijkstra(x);
    cout << d[n-1];
} 

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr), fin();
    int ts = 1;
    if (flag) {
        cin >> ts;
    }
    while (ts--) {
        ma1n(); 
    }
    return 0;
}