﻿#include <iostream>
#include <string>
#include <numeric> 
#include <vector>
using namespace std;


int syllable_count(string word) {
    string syllables = "aeiou";
    int count = 0;
    for (int i = 1; i < word.length(); i++) {
        if (syllables.find(word[i - 1]) == string::npos && syllables.find(word[i]) != string::npos) {
            count++;
        }
    }
    if (syllables.find(word[0]) != string::npos) {
        return 1 + count;
    }
    return count;
}

int hokku(vector<int> li) {
    for (long long i = 1; i < li.size() - 1; i++) {
        for (long long j = i + 1; j < li.size(); j++) {
            long long one = accumulate(li.begin(), li.begin() + i, 0);
            long long two = accumulate(li.begin() + i, li.begin() + j, 0);
            long long three = accumulate(li.begin() + j, li.begin() + li.size(), 0);
            if (one == 5 && three == 5 && two == 7) {
                return 1;
            }
        }
    }
    return 0;
}

int main()
{
    long long n, count = 0;
    cin >> n;
    vector <string> words(n);
    vector <int> syllables(n);
    for (long long i = 0; i < n; i++) {
        cin >> words[i];
        syllables[i] = syllable_count(words[i]);
    }
    for (long long i = 0; i < n; i++) {
        for (long long j = i + 3; j < n + 1; j++) {
            long long s = accumulate(syllables.begin() + i, syllables.begin() + j, 0);
            if (s == 17) {
                vector<int> vi = vector<int>(syllables.begin() + i, syllables.begin() + j);
                count += hokku(vi);
            }
            else if (s > 17) {
                break;
            }
        }
    }
    cout << count;
}