#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <chrono>
#include <string>
#include <string.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) (x).begin(),(x).end()
#define pb push_back
#define ll long long

ll gcd(ll a, ll b){
    if(!b) return a;
    return gcd(b, a % b);
}

ll lcm(ll a, ll b){
    return (a / gcd(a, b)) * b;
}

ll binpow(ll a, ll b, ll m){
    a %= m;
    if(b == 1) return a;
    ll k = binpow(a, b / 2, m) % m;
    k = k * k; k %= m;
    if(b % 2) k = (k * a) % m;
    return k % m;
}

void t_main(){
    int n, m, k; cin >> n >> m >> k;
    int a = 0;
    
    if(min(n, m) < k){
        cout << "Impossible" << "\n";
        return;
    }
    cout << "Possible" << "\n";
    for(int i = 0; i < n; i ++){
        for(int j = 0; j < m; j ++){
            if(i == j && a < k){
                a ++;
                cout << "*";
            }
            else
                cout << ".";
        }
        cout << "\n";
    }
    
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    
    int tt = 1;
    //cin >> tt;
    
    while(tt --) t_main();
    return 0;
}
