#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <chrono>
#include <string>
#include <string.h>
#include <set>
#include <map>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) (x).begin(),(x).end()
#define pb push_back
#define ll long long

ll gcd(ll a, ll b){
    if(!b) return a;
    return gcd(b, a % b);
}

ll lcm(ll a, ll b){
    return (a / gcd(a, b)) * b;
}

ll binpow(ll a, ll b, ll m){
    a %= m;
    if(b == 1) return a;
    ll k = binpow(a, b / 2, m) % m;
    k = k * k; k %= m;
    if(b % 2) k = (k * a) % m;
    return k % m;
}

int rev(int a){
    if(a % 10 == 0) return -1;
    vector <int> v;
    while(a > 0){
        v.pb(a % 10);
        a /= 10;
    }
    int res = 0;
    for(auto &x: v){
        res *= 10;
        res += x;
    }
    return res;
}



void t_main(){
   vector <int> x, y, res;
   vector <pair<int, int>> dif;
   
   int n, k1, k2, c1 = 0, c2 = 0, v1, v2; cin >> n >> k1 >> k2;
   x.resize(n + 1);
   dif.resize(n + 1);
   res.resize(n + 1);
   y.resize(n + 1);
   
    for(int i = 1; i <= n; i ++)
        cin >> x[i];
    
    for(int i = 1; i <= n; i ++)
        cin >> y[i];
    
    for(int i = 1; i <= n; i ++){
        dif[i].ff = llabs(x[i] - y[i]);
        dif[i].ss = i;
        if(x[i] > y[i]){
            res[i] = 1;
            c1 ++;
        }
        else if(x[i] < y[i]){
            c2 ++;
            res[i] = 2;
        }
        else{
            v1 = k1 - c1;
            v2 = k2 - c2;
            if(v1 > v2){
                res[i] = 1;
                c1 ++;
            }
            else{
                res[i] = 2;
                c2 ++;
            }
        }
    }
    sort(all(dif));
    int cnt = 0;
    if(c1 < k1){
        v1 = k1 - c1;
        
        for(int i = 1; cnt < v1; i ++){
            if(res[dif[i].ss] == 2){
                res[dif[i].ss] --;
                cnt ++;
            }
        }
    }
    else if(c2 < k2){
        v2 = k2 - c2;
        
        for(int i = 1; cnt < v2; i ++){
            if(res[dif[i].ss] == 1){
                res[dif[i].ss] ++;
                cnt ++;
            }
        }
    }
    
    int ans = 0;
    for(int i = 1; i <= n; i ++){
        if(res[i] == 1) ans += x[i];
        else ans += y[i];
    }
    cout << ans << "\n";
    
    for(int i = 1; i <= n; i ++){
        if(res[i] == 1) cout << "T ";
        else cout << "P ";
    }
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int tt = 1;
    //cin >> tt;
    
    while(tt --) t_main();
    return 0;
}
