#include <iostream>
#include <algorithm>
#include <functional>
#include <string>
#include <vector>
#include <deque>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <list>
#include <stack>

#define FAST1 std::ios_base::sync_with_stdio(false);
#define FAST2 std::cin.tie(0);

using ull = unsigned long long;
using ll = long long;
using namespace std;

int main()
{
	FAST1;
	FAST2;

	int n, a, b;
	cin >> n >> b >> a;

	vector<pair<int, int>> marks(n);

	ll sum = 0;

	for (int i = 0; i < n; ++i)
	{
		cin >> marks[i].first;
		sum += marks[i].first;
	}
	for (int i = 0; i < n; ++i)
		cin >> marks[i].second;
	vector<pair<int, int>> diff(n);
	for (int i = 0; i < n; ++i)
		diff[i] = make_pair(i, marks[i].second - marks[i].first);
	vector<int> ans(n + 1);
	ans[0] = sum;
	sort(diff.begin(), diff.end(), [](pair<int, int> first, pair<int, int> second)->bool {return first.second > second.second; });
	int max = -1;
	int ind = 0;
	for (int i = 1; i < n - b+2; ++i)
	{
		ans[i] = ans[i - 1] + diff[i - 1].second;
		if (i < n - b+1 && i >= a && ans[i] > max)
		{
			max = ans[i];
			ind = i;
		}
	}
	vector<bool> torp;
	torp.assign(n, true);
	for (int i = 0; i < ind; ++i)
	{
		torp[diff[i].first] = false;
	}
	cout << max << endl;
	for(int i = 0; i < n; ++i)
	{
		std::cout << (torp[i] ? "T " : "P ");
	}
	return 0;
}