#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

struct Line{
      ld k, b;
      Line(){}
      Line(ld x1, ld y1, ld x2, ld y2){
            k = (y1 - y2) / (x1 - x2);
            b = y1 - k * x1;
      }
      ld operator()(ld x){
            return k * x + b;
      }
};

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      int n; cin >> n;
      vector<ld> s(n), u(n);
      for(int i = 0; i < n; i ++){
            int ss, uu;
            cin >> ss >> uu;
            s[i] = ss;
            u[i] = uu;
      }
      vector<pair<ld, Line>> allT;
      for(int i = 0; i < n; i ++){
            for(int j = i + 1; j < n; j ++){
                  for(int k = j + 1; k < n; k ++){
                        ld t1 = (i - j)*(s[k] - s[j]) - (k - j)*(s[i] - s[j]);
                        ld t2 = (k - j)*(u[i] - u[j]) - (i - j)*(u[k] - u[j]);
                        ld t = t1 / t2;
                        if(t > 0)
                              allT.push_back({t, Line(s[i] + t * u[i], i, s[j] + t * u[j], j)});
                  }
            }
      }
      srand(time(NULL));
      random_shuffle(allT.begin(), allT.end());
      int mx = 0;
      for(auto [t, ln] : allT){
            int q = 0;
            for(int i = 0; i < n; i ++){
                  if(ln(s[i] + t * u[i]) == i)
                        ++ q;
            }
            mx = max(mx, q);
            if(clock() / (double)CLOCKS_PER_SEC > 1.9)
                  break;
      }
      cout << mx;
}
