﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctype.h>
#include <deque>
#include <cstring>
#include <set>
#include <bitset>
#include <map>
#include <chrono>
#include <random>
#include <unordered_map>
#include <stdio.h>

using namespace std;

//╱╱╭━╮╭━┳━━━┳━╮╱╱╱╱╱╱╭━┳━━━┳━╮╭━╮
//╱╭╯╭╋╯╭┫╭━╮┣╮╰╮╱╱╱╱╭╯╭┫╭━╮┣╮╰╋╮╰╮
//╭╯╭╋╯╭╯┃┃┃┃┃╰╮╰┳╮╭┳╯╭╯┃┃┃┃┃╰╮╰╋╮╰╮
//┃┃┃┃┃┃╱┃┃┃┃┃╱┃┃┃╰╯┃┃┃╱┃┃┃┃┃╱┃┃┃┃┃┃
//┃┃┃┃┃┃╱┃╰━╯┃╱┃┃┣╮╭┫┃┃╱┃╰━╯┃╱┃┃┃┃┃┃
//╰╮╰╋╮╰╮╰━━━╯╭╯╭╯╰╯╰╮╰╮╰━━━╯╭╯╭╋╯╭╯
//╱╰╮╰╋╮╰╮╱╱╱╭╯╭╯╱╱╱╱╰╮╰╮╱╱╱╭╯╭╋╯╭╯
//╱╱╰━╯╰━╯╱╱╱╰━╯╱╱╱╱╱╱╰━╯╱╱╱╰━╯╰━╯


//F(x) = (6 - x)(x(1 - t) + 2t - 1);
//x0 = (7 - 8t) / (2(1 - t));
//Q = max(F(1), F(2) и F(x0) если 1 <= x0 <= 2)
//Вернуть Q * 100 * T / 6
//t = X / 100
//X, T t = X / 100

bool chekGlas(char a) {
    if (a == 'a') { return true; }
    if (a == 'e') { return true; }
    if (a == 'i') { return true; }
    if (a == 'o') { return true; }
    if (a == 'u') { return true; }
    return false;
}

int colSlog(string str) {
    int sol = 0;
    string arr = 'c' + str;
    for (int i = 1; i < arr.size(); ++i) {
        if (!chekGlas(arr[i - 1]) && chekGlas(arr[i])) {
            ++sol;
        }
    }
    return sol;
}

int chekHokku(vector<pair<int, int>> &arr, int i) {
    int sol = 1;
    int colSlogLokal = 0;

    if (arr[i].first == 0) {
        sol *= arr[i].second;
    }
    while (colSlogLokal < 5 && i < arr.size()) {
        colSlogLokal += arr[i].first;
        ++i;
    }
    if (colSlogLokal != 5 || i == arr.size()) {
        return 0;
    }

    if (arr[i].first == 0) {
        sol *= arr[i].second;
    }
    while (colSlogLokal < 12 && i < arr.size()) {
        colSlogLokal += arr[i].first;
        ++i;
    }
    if (colSlogLokal != 12 || i == arr.size()) {
        return 0;
    }

    if (arr[i].first == 0) {
        sol *= arr[i].second;
    }
    while (colSlogLokal < 17 && i < arr.size()) {
        colSlogLokal += arr[i].first;
        ++i;
    }
    if (colSlogLokal != 17) {
        return 0;
    }

    if (i < arr.size() && arr[i].first == 0) {
        sol *= arr[i].second;
    }
    return sol;
}

void solveE() {
    vector<pair<int, int>> arr;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        string str;
        cin >> str;
        int col = colSlog(str);
        if (col == 0 && arr[arr.size()].first == 0) {
            arr[arr.size()].second++;
        }
        else {
            arr.push_back({ col, 0 });
        }
    }

    int sol = 0;
    for (int i = 0; i < arr.size(); ++i) {
        sol += chekHokku(arr, i);
    }
    cout << sol;

}

void solve() {
    solveE();
}

int main() {
    ios_base::sync_with_stdio(false);
    srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) { solve(); }

    return (0 - 0); //;(
}