#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}

void solve() {
    int res = 0;
    int n;
    cin >> n;
    vector<int> a(n);
    for(int k = 0; k < n; ++k) {
        string s;
        cin >> s;

        for(int i = 0; i < s.size(); ++i) {
            if ( (s[i] == 'a' || s[i] == 'e' || s[i] == 'i' || s[i] == 'o' || s[i] == 'u') && !(i > 0 && (s[i - 1] == 'a' || s[i - 1] == 'e' || s[i - 1] == 'i' || s[i - 1] == 'o' || s[i - 1] == 'u')) ) {
                a[k]++;
            }
        }
    }
    // cout << a << endl;
    for(int i = 0; i < n; ++i) {
        int cnt = 5;
        int j = i;
        while(j < n && cnt > 0) {
            cnt -= a[j];
            j++;
        }
        if (cnt != 0) continue;
        cnt = 7;
        while(j < n && cnt > 0) {
            cnt -= a[j];
            j++;
        }
        if (cnt != 0) continue;
        cnt = 5;
        while(j < n && cnt > 0) {
            cnt -= a[j];
            j++;
        }
        if (cnt != 0) continue;
        res++;
    }
    cout << res << endl;
}

int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
