#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}
int f = 1;
void my_gcd(ll a, ll b) {
    if (b == 0) return;
    cout << (f ? 1 : 2) << ' ' << -(a / b) << endl;
    f ^= 1;
    my_gcd(b, a % b);
    return;
}

void solve() {
    ll a, b; cin >> a >> b;
    if (a < 0) {
        ll x = (abs(a) / abs(b)) + 1;
        if (b < 0) {
            a -= x * b;
            cout << 1 << ' ' << -x << '\n';
        } else {
            a += x * b;
            cout << 1 << ' ' << x << '\n';
        }
    }
    if (b < 0) {
        ll x = (abs(b) / abs(a)) + 1;
        b += a * x;
        cout << 2 << ' ' << x << '\n';
    }
    dbg(a);
    dbg(b);
    my_gcd(a, b);
}

int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
