#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

double X, T;
double get(double t, double k, double x, double alpha) {
	return k * (t - alpha) + x;
}
int main() {

	int n;
	cin >> n;
	vector<ll> a(n);
	set<pair<int, int>> b;
	vector<ll> pref(n + 1, 0);
	for (int i = 0; i < n; ++i)
		for (int j = i; j >= 0; --j)
			if (b.find(make_pair(j, i)) == b.end()) {
				cout << "? " << j + 1 << ' ' << i + 1 << endl;
				ll sum; cin >> sum;
				a[i] = sum - (pref[i] - pref[j]);
				pref[i + 1] = pref[i] + a[i];
				int l, r;
				cin >> l >> r;
				b.insert(make_pair(min(l, r) - 1, max(l, r) - 1));
				break;
			}
	cout << '!' << endl;
	for (int i = 0; i < n; ++i)
		cout << a[i] << ' ';
	cout << endl;
	return 0;
}