#include <bits/stdc++.h>

using namespace std;
using str = string;
using ll = long long;
using ld = long double;
template <typename T> using vec = vector<T>;
template <typename A, typename B> using pr = pair<A, B>;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define pf push_front
#define sz(x) (ll) x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define clz(x) __builtin_clz(x)
#define ctz(x) __builtin_ctz(x)
#define popcount(x) __builtin_popcount(x)

#define endl '\n'

struct Solver
{
    vec<vec<int>> g;
    vec<int> u, d;

    void run()
    {
        int n, m;
        cin >> n >> m;

        g.resize(n);
        u.resize(n, 0);
        d.resize(n, INT_MIN);
        for(int i = 0; i < m; i++)
        {
            int x, y;
            cin >> x >> y;

            x--, y--;
            g[x].pb(y);
            g[y].pb(x);
        }

        ll x;
        cin >> x;

        vec<ll> a(n);
        for(auto &i : a)
            cin >> i;

        queue<int> q;
        u[0] = 1;
        d[0] = x > a[0] ? x : x / 2;
        q.push(0);
        while(!q.empty())
        {
            int v = q.front();
            q.pop();

            for(auto i : g[v])
            {
                ll t = (a[i] >= d[v] ? d[v] / 2 : d[v]);
                if(d[i] < t)
                {
                    u[i] = true;
                    d[i] = t;
                    q.push(i);
                }
            }
        }

        cout << d[n - 1];
    }
};

void boost()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

int main()
{
    boost();

    int t = 1;
    // cin >> t;

    while(t--)
    {
        Solver s;
        s.run();
    }
}
