import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class J {
   
    public static long reverseNumber(long n) {
        long reversedNumber = 0, remainder;

        while (n != 0) {
            remainder = n % 10;
            reversedNumber = reversedNumber * 10 + remainder;
            n /= 10;
        }
        return reversedNumber;
    }


    public static void main(String[] args) {
        long a, b;
        Scanner s = new Scanner(System.in);
        a = s.nextLong();
        b = s.nextLong();
        long res = 0;
        Set<Long> squares = new HashSet<>();
        ArrayList<Long> squaresV = new ArrayList<>();
        for (long i = 0; i < 1000000; i++) {
            if ((i*i) % 10 != 0) {
                squares.add(i*i);
                squaresV.add(i*i);
            }
        }
        for (int i = 0; i < squaresV.size(); i++) {
            long p = squaresV.get(i);
            long r = reverseNumber(p);
            if (p <= b && p >= a  &&  squares.contains(r)) {
                res++;
            }
        }
        System.out.print(res);
    }
}
