import java.io.*;
import java.util.StringTokenizer;

public class K {

    public static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    public static StringTokenizer tokenizer = null;

    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void flush() throws IOException {
        writer.flush();
    }

    public static void println() throws IOException {
        writer.newLine();
    }

    public static void print(String s) throws IOException {
        writer.write(s);
    }

    public static void println(String s) throws IOException {
        print(s);
        println();
    }

    public static void main(String[] args) throws IOException {
        double X = Double.parseDouble(next());
        double T = Double.parseDouble(next());
        double k = (100.0 - X) * 6.0 / T;
        double b = 2 * X - 100;
        double x0 = (k*T - b) / (2*k);
        if (x0<T / 3 && x0>T / 6) {
            double res = Math.max(X * (T - T / 6.0), Math.max(100 * (T - T / 3.0),(k*x0+b)*(T-x0)));
            println(res + "");
        } else {
            println(Math.max(X * (T - T / 6.0), 100 * (T - T / 3.0)) + "");
        }
        flush();
    }
}
