#include<iostream>
#include<vector>
#include<set>


using namespace std;
using ll = long long;

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<ll>> list(n);
    int a, b;

    for (int i = 0; i < m; ++i) {
        cin >> a >> b;
        --a;
        --b;
        list[a].push_back(b);
        list[b].push_back(a);
    }

    int k;
    cin >> k;

    vector<ll> droids(n);
    for (int i = 0; i < n; ++i) {
        cin >> droids[i];
    }

    set<pair<ll, ll>> s;
    vector<ll> countClones(n, -1);

    if (k > droids[0]) {
        s.insert({k, 0});
        countClones[0] = k;
    } else {
        s.insert({k / 2, 0});
        countClones[0] = k / 2;
    }

    while (!s.empty()) {
        auto current = s.begin();
        s.erase(s.begin());
        for (auto i: list[current->second]) {
            ll clones;
            if (current->first > droids[i]) {
                clones = current->first;
            } else {
                clones = current->first / 2;
            }

            if (countClones[i] < clones) {
                s.erase({countClones[i], i});
                countClones[i] = clones;
                s.insert({countClones[i], i});
            }
        }
    }
    if (countClones[n - 1] > 0) {
        cout << countClones[n - 1];
    } else {
        cout << 0 << endl;
    }
}