#include <bits/stdc++.h>

using namespace std;

signed main() {
    int n, m;
    cin >> n >> m;
    int start = 0, finish = n - 1;

    vector<vector<int>> a(n, vector<int>(n, -1));
    vector<pair<int, int> > inp;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        inp.push_back({u, v});
    }
    int clones;
    cin >> clones;
    vector<int> dr(n);
    for (int i = 0; i < n; i++) {
        cin >> dr[i];
    }
    if (n == 1) {
        if (dr[0] > clones) {
            cout << clones / 2;
        } else {
            cout << clones;
        }
        return 0;
    }
    for (int i = 0; i < m; i++) {
        int u = inp[i].first, v = inp[i].second;
        a[u][v] = dr[v];
        a[v][u] = dr[u];
    }

    set<pair<int, int> > s;
    vector<int> p(n, -1);
    vector<int> dist(n, 1e9);
    dist[start] = 0;
    s.insert({0, start});
    while (!s.empty()) {
        int v = s.begin()->second;
        s.erase(s.begin());
        for (int i = 0; i < n; i++) {
            if (a[v][i] != -1) {
                if (dist[i] > dist[v] + a[v][i]) {
                    s.erase({dist[i], i});
                    dist[i] = dist[v] + a[v][i];
                    p[i] = v;
                    s.insert({dist[i], i});
                }
            }
        }
    }
    int qr = p[finish];
    vector<int> ans;
    ans.push_back(n - 1);
    while (qr != -1) {
        ans.push_back(qr);
        qr = p[qr];
    }
    reverse(ans.begin(), ans.end());
    for (auto x : ans) {
        clones = clones / (1 + int(bool(clones <= dr[x])));
    }
    cout << clones;
    return 0;
}