#include<unordered_map>
#include<algorithm>
#include<iostream>
#include<vector>
#include<deque>
#include<cmath>
#include<map>

using namespace std;
using ll = long long;

//short matrix[10000][100000];
struct info {
    pair<ll, ll> numbers;
    ll counts;
};

struct forPred {
    pair<ll, ll> pred;
    ll type, k;
};

struct forFuncs {
    ll a, b, type, k;
};

forFuncs first(ll a, ll b) {
    ll k = abs(a / b);
    if (a % b == 0) {
        if (a > 0 && b > 0)
            return {0, b, 1, -1 * k};
        else
            return {0, b, 1, k};
    }
    if (a > 0) {
        if (b > 0)
            return {a - abs(k * b), b, 1, -1 * k};
        if (b < 0)
            return {a - abs(k * b), b, 1, k};
    }
    if (a < 0) {
        if (b > 0)
            return {a + abs(k * b), b, 1, -1 * k};
        if (b < 0)
            return {a + abs(k * b), b, 1, k};
    }
}

forFuncs second(ll a, ll b) {
    ll k = abs(b / a);
    if (b % a == 0) {
        if (b > 0 && a > 0)
            return {a, 0, 2, -1 * k};
        else
            return {a, 0, 2, k};
    }
    if (b > 0) {
        if (a > 0)
            return {a, b - abs(k * a), 2, -1 * k};
        if (a < 0)
            return {a, b - abs(k * a), 2, k};
    }
    if (b < 0) {
        if (a > 0)
            return {a, b + abs(k * a), 2, -1 * k};
        if (a < 0)
            return {a, b + abs(k * a), 2, k};
    }
}

int main() {
    ll a, b;

    cin >> a >> b;

    deque<info> d;
    d.push_back({{a, b}, 0});
    map<pair<ll, ll>, forPred> m;
    pair<ll, ll> ans;
    m[{a, b}] = {{-1, -1}, -1, -1};
    while (!d.empty()) {
        info current = d.front();
        d.pop_front();
        if (current.counts < 50) {
            forFuncs numbersFirst = first(current.numbers.first, current.numbers.second);
            forFuncs numbersSecond = second(current.numbers.first, current.numbers.second);
            if (numbersFirst.a != current.numbers.first || numbersFirst.b != current.numbers.second) {
                d.push_back({{numbersFirst.a, numbersFirst.b}, current.counts + 1});
                m[{numbersFirst.a, numbersFirst.b}] = {{current.numbers}, numbersFirst.type, numbersFirst.k};
            }
            if (numbersSecond.a != current.numbers.first || numbersSecond.b != current.numbers.second) {
                d.push_back({{numbersSecond.a, numbersSecond.b}, current.counts + 1});
                m[{numbersSecond.a, numbersSecond.b}] = {{current.numbers}, numbersSecond.type, numbersSecond.k};
            }

            if (numbersFirst.a == 0) {
                cout << current.counts + 1 << endl;
                ans = {numbersFirst.a, numbersFirst.b};
                break;
            }
            if (numbersSecond.b == 0) {
                cout << current.counts + 1 << endl;
                ans = {numbersSecond.a, numbersSecond.b};
                break;
            }
        }
    }
    vector<pair<ll, ll>> ansVector;
    pair<ll, ll> current = ans;
    while (m[current].type != -1) {
        forPred parsed = m[current];
        ansVector.push_back({parsed.type, parsed.k});
        current = {parsed.pred};
    }
    reverse(ansVector.begin(), ansVector.end());
    for (int i = 0; i < ansVector.size(); ++i) {
        cout << ansVector[i].first << " " << ansVector[i].second << endl;
    }
    cout << endl;
    return 0;
}