#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9;
int x, n;

vector <vector <int>> g;
vector <int> dist;
vector <int> w;

void dijkstra() {
    dist.assign(n + 1, -inf);
    dist[0] = x;
    set <pair<int, int>> pq;
    pq.insert({0, 0});
    while (!pq.empty()) {
        int u = pq.begin()->second;
        pq.erase(pq.begin());
        for (auto v : g[u]) {
            if (dist[u] > w[v] && dist[u] > dist[v]) {
                pq.erase({dist[v], v});
                dist[v] = dist[u];
                pq.insert({dist[v], v});
            } else if (dist[u] <= w[v] && dist[u] / 2 > dist[v]) {
                pq.erase({dist[v], v});
                dist[v] = dist[u] / 2;
                pq.insert({dist[v], v});
            }
        }
    }
}

int main()
{
    int m;
    cin >> n >> m;
    g.resize(n + 1, vector <int> (0));
    w.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    g[0].push_back(1);
    cin >> x;
    for (int i = 1; i <= n; i++) {
        cin >> w[i];
    }
    dijkstra();
    cout << dist[n] << '\n';
}
