#include <unordered_set>
#include <unordered_map>
//#include <ext/rope>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <chrono>
#include <string>
#include <vector>
#include <bitset>
#include <cstdio>
#include <random>
#include <stack>
#include <cmath>
#include <queue>
#include <ctime>
#include <map>
#include <set>

//using namespace __gnu_cxx;
using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;   
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define pb push_back
#define eb emplace_back 
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
 
const int INF = 1e9;
const ld EPS = 1e-8;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2e5 + 1000;

#define fast() ios_base::sync_with_stdio(0); cin.tie(0)

bool ans[MAXN];
int am[MAXN], bm[MAXN];
pair<int, int> c[MAXN];

int main() {
    fast();
    
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, a, b;
    cin >> n >> a >> b;
    for (int i = 0; i < n; i++) {
        cin >> am[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> bm[i];
    }

    int ca = 0, cb = 0;
    ll sum = 0;

    for (int i = 0; i < n; i++) {
        c[i].first = abs(am[i] - bm[i]);
        c[i].second = i;
        if (am[i] > bm[i]) {
            ans[i] = true;
            sum += am[i];
            ca++;
        }
        else {
            sum += bm[i];
            cb++;
        }
    }

    sort(c, c + n);

    for (int i = 0; i < n; i++) {
        if (ans[c[i].second] && cb < b) {
            sum -= c[i].first;
            ans[c[i].second] = false;
            cb++;
        }
        if (!ans[c[i].second] && ca < a) {
            sum -= c[i].first;
            ans[c[i].second] = true;
            ca++;
        }
    }

    cout << sum << '\n';
    for (int i = 0; i < n; i++)
        if (ans[i])
            cout << "T" << ' ';
        else
            cout << "P" << ' ';

    cout << '\n';

    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif 
    return 0;
}