#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18 + 7;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

bool glas(char x) {
    return x == 'a' || x == 'e' || x == 'o' || x == 'u' || x == 'i';
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &x : a) {
        x = 0;
        string s;
        cin >> s;
        int q = s.size();
        for (int i = 0; i < q; ) {
            int j = i + 1;
            while (j < q && glas(s[j]) == glas(s[i])) j++;
            x += glas(s[i]);
            i = j;
        }
    }

    int res = 0;
    for (int i = 0; i < n; i++) {
        int cur_sum = 0, was5 = 0, was7 = 0;
        for (int j = i; j < n; j++) {
            cur_sum += a[j];
            if (was5 && cur_sum > 7) break;
            if (was7 && cur_sum > 5) break;
            if (!was5 && cur_sum > 5) break;
            if (was7 && cur_sum == 5) {
                res++;
                break;
            } else if (was5 && !was7 && cur_sum == 7) {
                was7 = 1;
                cur_sum = 0;
            } else if (!was5 && cur_sum == 5) {
                was5 = 1;
                cur_sum = 0;
            }
        }
    }

    cout << res;
}

signed main() {
    fast();
    solve();
    return 0;
}
