#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace std;
using namespace __gnu_pbds;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

///pragms:

//#pragma GCC optimize("Ofast,O3,unroll-loops")

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native,avx2")

using ull = unsigned long long;
using ll = long long;
using ld = long double;
//using ui = unsigned int;

/*const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new ( size_t n ) {
	char *res = mem + mpos;
	mpos += n;
	assert(mpos <= MAX_MEM);
	return (void *)res;
}
inline void operator delete ( void * ) { }*/

#define int int_fast32_t

const int N = 300;
int x[N];
int v[N];
ld c[N];

const ld eps = 1e-10;

signed main() {
    ios;
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> v[i];
    }
    int it = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            it = 0;
            for (int k = 0; k < n; ++k) {
                if (k == i || k == j)
                    continue;
                ld t = (ld)(j * x[i] - i * x[j] - x[i] * k + x[j] * k - j * x[k] + i * x[k]) /
                (ld)(j * v[k] - i * v[k] + v[i] * k - v[j] * k - j * v[i] + i * v[j]);
                if (t < -eps)
                    continue;
                c[it++] = t;
            }
            if (ans >= it + 2)
                continue;
            sort(c, c + it);
            int r = -1;
            for (int l = 0; l < it; ++l) {
                while (r + 1 < it && abs(c[r + 1] - c[l]) < eps)
                    ++r;
                ans = max(ans, r - l + 1 + 2);
            }
        }
    }
    cout << ans;
    return 0;
}

