#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

const int MAXN = 200'200;
vector<int> G[MAXN];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
      int a, b;
      cin >> a >> b;
      G[a - 1].emplace_back(b - 1);
      G[b - 1].emplace_back(a - 1);
  }
  vector<int> d(n, 0);
  int x;
  cin >> x;
  vector<int> a(n);
  for (int i = 0; i < n; ++i)
      cin >> a[i];
  d[0] = x > a[0] ? x : x / 2;
  set<pair<int, int>> Q;
  Q.emplace(d[0], 0);
  while (!Q.empty()) {
      int v = Q.rbegin()->second;
      Q.erase(--Q.end());
      for (int u : G[v]) {
          int cur = d[v] > a[u] ? d[v] : d[v] / 2;
          if (cur > d[u]) {
              Q.erase(make_pair(d[u], u));
              d[u] = cur;
              Q.emplace(d[u], u);
          }
      }
  }
  cout << d[n - 1] << '\n';
  return 0;
}
