#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  vector<int> ss(n);
  vector<int> vv(n);
  for (int i = 0; i < n; ++i)
      cin >> ss[i] >> vv[i];
  int ans = 1;
  for (int i = 0; i < n; ++i) {
      vector<int> s(n);
      vector<int> v(n);
      for (int j = i + 1; j < n; ++j) {
          s[j] = ss[j] - ss[i];
          v[j] = vv[j] - vv[i];
      }
      for (int j = i + 1; j < n; ++j) {
          int cnt_any = 0;
          vector<pair<int, int>> all;
          for (int l = j + 1; l < n; ++l) {
              int a = (l - i) * v[j] - (j - i) * v[l];
              int b = (j - i) * s[l] - (l - i) * s[j];
              if (a == 0) {
                  if (b == 0)
                      ++cnt_any;
              } else {
                  int d = gcd(abs(a), abs(b));
                  if (a < 0 && b < 0)
                      a *= -1, b *= -1;
                  all.emplace_back(a / d, b / d);
              }
          }
          ans = max(ans, 2 + cnt_any);
          if (all.empty())
              continue;
          sort(all.begin(), all.end());
          int cnt_same = 1;
          for (int l = 1; l < (int) all.size(); ++l) {
              if (all[l] != all[l - 1]) {
                  ans = max(ans, 2 + cnt_any + cnt_same);
                  cnt_same = 1;
              } else
                  ++cnt_same;
          }
          ans = max(ans, 2 + cnt_any + cnt_same);
      }
  }
  cout << ans << '\n';
  return 0;
}
