#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  int a, b;
  cin >> a >> b;
  vector<int> x(n);
  vector<int> y(n);
  for (int i = 0; i < n; ++i)
      cin >> x[i];
  for (int i = 0; i < n; ++i)
      cin >> y[i];
  vector<int> xx;
  vector<int> yy;
  for (int i = 0; i < n; ++i) {
      if (x[i] >= y[i])
          xx.emplace_back(i);
      else
          yy.emplace_back(i);
  }
  if (xx.size() >= a && yy.size() >= b);
  else if (yy.size() < b) {
      sort(xx.begin(), xx.end(), [&x, &y](int a, int b) {
          return x[a] - y[a] > x[b] - y[b];
      });
      while (yy.size() < b) {
          yy.emplace_back(xx.back());
          xx.pop_back();
      }
  } else {
      sort(yy.begin(), yy.end(), [&x, &y](int a, int b) {
          return y[a] - x[a] > y[b] - x[b];
      });
      while (xx.size() < a) {
          xx.emplace_back(yy.back());
          yy.pop_back();
      }
  }
  vector<char> ans(n, 'P');
  for (int i : xx)
      ans[i] = 'T';
  int cost = 0;
  for (int i : xx)
      cost += x[i];
  for (int i : yy)
      cost += y[i];
  cout << cost << '\n';
  for (char c : ans)
      cout << c << ' ';
  cout << '\n';
  return 0;
}
