#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using str = string;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;

void solve() {
    int n, k;
    cin >> n >> k;
    vi p(n), q(n);
    rep(i, n) cin >> p[i];
    rep(i, n) cin >> q[i];
    if (k == n) {
        if (p != q) {
            cout << "NO\n";
            return;
        }
        cout << "YES\n0\n";
        return;
    }
    if (k + 1 == n) {
        vector<pair<int, int>> ans;
        while (p[0] != q[0]) {
            ans.emplace_back(1, 0);
            rotate(p.begin(), p.begin() + 1, p.end());
        }
        if (p != q) {
            cout << "NO\n";
            return;
        }
        cout << "YES\n";
        cout << ans.size() << '\n';
        for (auto &[a, b] : ans) cout << a + 1 << ' ' << b + 1 << '\n';
        return;
    }
    vector<int> a(n);
    {
        vector<int> ind(n);
        rep(i, n) ind[q[i] - 1] = i;
        rep(i, n) a[i] = ind[p[i] - 1];
    }
    vector<pair<int, int>> ans;
    // sort a
    auto op = [&](int i) {
        ans.emplace_back(i, i + 1);
        int j = i + k;
        for (int e = j; e > i; --e) swap(a[e], a[e - 1]);
    };
    for (int d = n - 1; d >= k + 2; ++d) {
        int pos = 0;
        while (a[pos] != d) pos++;
        if (pos == d) continue;
        while (pos < k - 1) {
            op(0);
            pos++;
        }
        int from = pos - k + 1;
        // (d + 1) - k
        ans.emplace_back(from, d + 1 - k);
        rotate(a.begin() + from, a.begin() + from + k, a.begin() + d + 1);
        assert(a[d] == d);
    }
    int cur = 0;
    int start = 0;
    {
        int p1 = 0;
        while (a[p1] != 0) p1++;
        if (p1 < k + 1) {
            cur = 1;
            start = p1;
        } else {
            cur = 0;
            start = p1 - 1;
        }
    }
    for (int t = 1; t < k + k % 2; ++t) {
        int w = 0;
        while (a[w] != t) w++;
        if (cur == 1) {
            if ((start + t) % (k + 1) == w) continue;
            if (w != k + 1 && w != 0) {
                while (a[0] != t) {
                    op(0);
                    start = (start + 1) % (k + 1);
                    w = (w + 1) % (k + 1);
                }
            }
            if (w == k + 1) {
                cur = 1;
            } else {
                assert(w == 0);
                cur = 0;
            }
        } else if (w != 0) {
            w--;
            if ((start + t) % (k + 1) == w) continue;
            if (w != k) {
                while (a[k + 1] != t) {
                    op(1);
                    start = (start + 1) % (k + 1);
                    w = (w + 1) % (k + 1);
                }
            }
            w++;
            assert(w == k + 1);
            cur = 1;
        } else {
            assert(w == 0 && cur == 0);
        }
        if (cur == 1) {
            while(a[k] != t - 1) op(0);
            start = k + 1 - t;
            start--;
            cur = 0;
        } else {
            while(a[k] != t - 1) op(1);
            start = k + 1 - t;
            cur = 1;
        }
    }
    rep(_, k + 3) {
        if (a[0] == 0) break;
        ans.emplace_back(2, 0);
        rotate(a.begin(), a.begin() + 2, a.begin() + k + 2);
    }
    bool ok = true;
    for(int i = 1; i < n; ++i) ok &= (a[i] == i);
    if (!ok) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << ans.size() << '\n';
    for(auto &[x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    rep(_, tests) {
        solve();
    }
    return 0;
}