#include <bits/stdc++.h>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
constexpr int INF = (numeric_limits<int>::max()) / 2;
constexpr long long INFLL = (numeric_limits<long long>::max()) / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ld = long double;
ld eps = 1e-9;

struct point {
    ld x, y;

    point() {};

    point(ld x, ld y) : x(x), y(y) {};
};

struct line {
    ld a, b, c;

    line() {};

    line(point p, point q) {
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
    }

    ld operator()(point p) {
        return a * p.x + b * p.y + c;
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<point> vv(n);
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        int si;
        cin >> si >> v[i];
        vv[i] = {(ld) v[i], (ld) i};
    }
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            vector<ld> t;
            int cur = 2;
            for (int k = 0; k < n; ++k) {
                if (k == i || k == j) {
                    continue;
                }
                auto check = [&](ld ti) -> int {
                    line gg({vv[i].x + v[i] * ti, vv[i].y}, {vv[j].x + v[j] * ti, vv[j].y});
                    point cur = {vv[k].x + v[k] * ti, vv[k].y};
                    if (gg(cur) > eps) {
                        return 1;
                    }
                    if (-eps <= gg(cur) && gg(cur) <= eps) {
                        return 0;
                    }
                    return -1;
                };
                if (check(0) == 0 && check(1e6) == 0) {
                    ++cur;
                } else {
                    ld l = 0, r = 2e6;
                    for (int it = 0; it < 228; ++it) {
                        ld m = (l + r) / 2;
                        if (check(m) > 0) {
                            r = m;
                        } else {
                            l = m;
                        }
                    }
                    if (check(l) == 0) {
                        t.push_back(l);
                    }
                }
            }
            sort(all(t));
            for (int k = 0; k < t.size(); ++k) {
                int curk = upper_bound(all(t), t[k] + eps) - t.begin() - k;
                ans = max(ans, curk + cur);
            }
            ans = max(ans, cur);
        }
    }
    cout << ans;
}