#include <bits/stdc++.h>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
constexpr int INF = (numeric_limits<int>::max()) / 2;
constexpr long long INFLL = (numeric_limits<long long>::max()) / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

vector<pair<int, long long>> ans;

void gcd(long long a, long long b) {
    if (a == 0 || b == 0) {
        return;
    }
    if (abs(a) < abs(b)) {
        ans.push_back({2, -b / a});
        b += (-b / a) * a;
        gcd(a, b);
    } else {
        ans.push_back({1, -a / b});
        a += (-a / b) * b;
        gcd(a, b);
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    long long a, b;
    cin >> a >> b;
    if (a == 0 || b == 0) {
        cout << 0;
        return 0;
    }
    gcd(a, b);
    if (ans.size() <= 2) {
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); i++) {
            cout << ans[i].first << " " << ans[i].second << "\n";
        }
    } else {
        ans.clear();
        if (a > 0 && b > 0 || a < 0 && b < 0) {
            if (a > b) {
                a -= 2 * b;
                ans.push_back({1, -2});
            } else {
                b -= 2 * a;
                ans.push_back({2, -2});
            }
        } else {
            if (a > b) {
                a += 2 * b;
                ans.push_back({1, 2});
            } else {
                b += 2 * a;
                ans.push_back({2, 2});
            }
        }
        gcd(a, b);
        cout << ans.size() << "\n";
        for (int i = 0; i < ans.size(); i++) {
            cout << ans[i].first << " " << ans[i].second << "\n";
        }
    }
}