#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stdint.h>

using namespace std;

int slogi(string s) {
	bool flag = 0;
	int count = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == 'e' || s[i] == 'a' || s[i] == 'i' || s[i] == 'o' || s[i] == 'u') {
			if (!flag) {
				count++;
				flag = 1;
			}
		} else {
			flag = 0;
		}
	}
	return count;
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long n;
	cin >> n;
	vector<string> words(n);
	for (int i = 0; i < n; i++) {
		cin >> words[i];
	}
	
	vector<long long> sl(n);
	for (int i = 0; i < n; i++) sl[i] = slogi(words[i]);

	long long res = 0;

	
	for (int i = 0; i < n; i++) {
		int count = 0;
		int curr_ind = i;
		while (count < 5 && curr_ind < n) {
			count += sl[curr_ind];
			curr_ind++;
		}
		if (count != 5 || (curr_ind >= n && count < 5)) {
			continue;
		}
		count = 0;
		while (count < 7 && curr_ind < n) {
			count += sl[curr_ind];
			curr_ind++;
		}
		if (count != 7 || (curr_ind >= n && count < 7)) {
			continue;
		}
		count = 0;
		while (count < 5 && curr_ind < n) {
			count += sl[curr_ind];
			curr_ind++;
		}
		if (count != 5 || (curr_ind >= n && count < 5)) {
			continue;
		}
		res++;
	}

	cout << res;

	return 0;
}