#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <iomanip>
#include <cstdlib>
#include <fstream>
#include <ctime>
#include <random>

#define int long long

using namespace std;

const int INF = 1e9;
int a[100005], b[100005], d[100005], t[400005], dp[100005];

void build(int v, int tl, int tr)
{
    if(tl == tr)
    {
        t[v] = dp[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int find_min(int v, int tl, int tr, int l, int r)
{
    if(l > r)
        return INF;
    if(l == tl && r == tr)
        return t[v];
    int tm = (tl + tr) / 2;
    return min(find_min(v * 2, tl, tm, l, min(r, tm)), find_min(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
        d[i] = b[i] - a[i] + 1;
    }
    for(int i = 0; i < n; i++)
    {
        if(i < d[0] - 1)
            dp[i] = INF;
        else
            dp[i] = abs(i - b[0]);
    }
    build(1, 0, n - 1);
    for(int i = 1; i < m; i++)
    {
        for(int j = 0; j < n; j++)
        {
            if(j < d[i] - 1)
            {
                dp[j] = INF;
                continue;
            }
            int l = j - d[i] + 1;
            int r = min(n - 1, j + d[i - 1] - 1);
            dp[j] = abs(j - b[i]) + find_min(1, 0, n - 1, l, r);
        }
        build(1, 0, n - 1);
    }
    cout << find_min(1, 0, n - 1, 0, n - 1);
    return 0;
}
