#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

double eps = 1e-9;

long long reverse(long long num)
{
    vector<long long> x;
    while(num)
    {
        x.push_back(num % 10);
        num /= 10;
    }
    
    long long res = 0;
    for(int i = 0; i < x.size(); i++)
    {
        res *= 10;
        res += x[i];
    }
    
    return res;
}

int main()
{
    
    long long a, b, cnt = 0;
    cin >> a >> b;
    
    long long start = sqrt(a);
    if(start * start != a) start++;
    long long end = sqrt(b);
    
    for(long long i = start; i <= end; i++)
    {
        if(i % 10 == 0) continue;
        long long rev = reverse(i * i);
        long long sq = sqrt(rev);
        if(sq * sq == rev)
        {
            cnt++;
        }
        
        
    }
    
    cout << cnt;
}