#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <map>
#define pb push_back
#define F first
#define S second
#define LL long long
#define Matrix vector <vector <long long>>

using namespace std;

void Ludociel(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL); cout.tie(NULL);
    #ifdef Kultivator
        //freopen("W.txt", "r", stdin);
    #endif // Kultivator
}

const int Mx = (int)1e6 + 7;
const int Md = (int)1e9 + 7;
const long long Inf = (long long)1e18 + 7;

int n, m, x, A[Mx], d[Mx];
vector <int> g[Mx];

void Dfs(int v){
    if(v == n) return;
    for(int to : g[v]){
        int tox = (d[v] > A[to] ? d[v] : (d[v] / 2));
        if(tox > d[to]){
            d[to] = tox;
            Dfs(to);
        }
    }
}

int main(){
    Ludociel();
    /* set <int> A;
    A.insert(34);
    A.erase(prev(A.end()));
    cout << *A.rbegin(); */
    cin >> n >> m;
    for(int i = 1, u, v; i <= m; i++){
        cin >> u >> v;
        g[u].pb(v); g[v].pb(u);
    }
    cin >> x;
    for(int i = 1; i <= n; i++) cin >> A[i];
    d[1] = (x > A[1] ? x : (x / 2));
    Dfs(1);
    cout << d[n] << '\n';
}
