#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int sign(ll a) {
    if (a < 0) return -1;
    if (a > 0) return 1;
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    ll a, b, f = 0;
    cin >> a >> b;
    vector<pair<int, ll>> ass;
    while (a != 0 && b != 0)
    {
        f++;
        if (abs(a) > abs(b))
        {
            // ll c = abs(a) / abs(b);
            ll remainds = 0;
            if (a < 0) remainds = b + a;
            else remainds = a % b; 
            ll c = (abs(a) - remainds) / abs(b);
            if (sign(a) * sign(b) < 0)
            {
                ass.push_back({1, c});
                a += c * b;
            }
            else
            {
                ass.push_back({1, -c});
                a -= c * b;
            }
        }
        else
        {
            ll remainds = 0;
            if (b < 0) remainds = a + b;
            else remainds = b % a; 
            ll c = (abs(b) - remainds) / abs(a);
            if (sign(a) * sign(b) < 0)
            {
                ass.push_back({2, c});
                b += c * a;
            }
            else
            {
                ass.push_back({2, -c});
                b -= c * a;
            }
        }
        // if (f > 50)
        // {
        //     cout << 1 / 0;
        // }
    }
    cout << ass.size() << "\n";
    // assert(f <= 50);
    for (int i = 0; i < f; i++)
    {
        cout << ass[i].first << " " << ass[i].second << "\n";
    }
}