#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    cout << fixed;
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif

    ld x, t;
    cin >> x >> t;

    ld ans = 0;
    for (ld i = 0; i < x; i += (ld)(1e-7)) {
        ld dt = (i * t) / ((ld)6 * x);
        ld goga = t - dt;
        ans = max(ans, i*goga);
        //cout << i << '\n';
    }
    ld b = 2*x - 100;
    ld k = (6 * (100 - x)) / t;
    for (ld i = x; i <= (ld)100; i += (ld)(1e-7)){
        ld dt = (i - b) / k;
        ld goga = t - dt;
        ans = max(ans, i*goga);
    }
    cout << ans;
}