#include <iostream>
#include <vector>
#include <iomanip>
#include <deque>

#define fr first
#define se second
#define ll int

using namespace std;

const ll N = 2 * 1e5;

vector< ll > G[N + 1];
vector< ll > a(N + 1);

vector<bool>used;
int mx = -1,n;

void dfs(int pos, int cnt) {
    if(a[pos] >= cnt) {
        cnt /= 2;
    }
    if(cnt == 0) {
        return;
    }
    if(pos == n && cnt > mx) {
        mx = cnt;
        return;
    }
    for(int i = 0; i < G[pos].size(); i++) {
        if(used[G[pos][i]]) {
            used[G[pos][i]] = false;
            dfs(G[pos][i], cnt);
            used[G[pos][i]] = true;
        }
    }
}

main() {
    ll m;
    cin>>n>>m;

    for(int i = 0; i < m; i++) {
        int x,y;
        cin>>x>>y;
        G[x].push_back(y);
    }

    ll x;
    cin>>x;

    used.resize(n + 1, true);
    for(int i = 1; i <= n; i++) {
        cin>>a[i];
    }

    used[1] = false;
    dfs(1, x);

    cout<<(mx == -1 ?  0 : mx) ;
}
