#include <iostream>
#include <vector>
#include <iomanip>
#include <deque>

#define fr first
#define se second
#define ll long long

using namespace std;

const ll N = 2e5;

vector< ll > G[N + 1];

main() {
    ll n,m;
    cin>>n>>m;

    for(int i = 0; i < m; i++) {
        int x,y;
        cin>>x>>y;
        G[x].push_back(y);
    }

    ll x;
    cin>>x;

    vector< ll > a(n + 1);
    for(int i = 1; i <= n; i++) {
        cin>>a[i];
    }

    vector< ll > V(n +1, 0);
    deque <int> q;
    q.push_back(1);
    V[1] = (x < a[1] ? x / 2 : x);

    while(!q.empty()) {
        int pos = q.front();
        q.pop_front();
        if(V[pos] != 0) {
            for(int i = 0; i < G[pos].size(); i++) {
                ll t = V[pos];
                if(V[G[pos][i]] < t) {
                    if(t <= a[G[pos][i]]) {
                        t /= 2;
                    }
                    V[G[pos][i]] = t;
                    q.push_back(G[pos][i]);
                }
            }
        }
    }
    cout<<V[n];
}
