#define _CRT_SECURE_NO_WARNINGS
#define _GLIB_CXX_DEBUG
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <iomanip>
#include <sstream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define ff first
#define ss second
//#define endl '\n'

using namespace std;
using ll = long long;
using vi = vector<int>;

template<typename T>
bool rMin(T& x, const T& y)
{
	if (x > y)
	{
		x = y;
		return true;
	}
	return false;
}
template<typename T>
bool rMax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(6);
	
	int n, m;
	cin >> n >> m;
	deque <pair<int, int>> mas;
	mas.push_back({ 1,n });
	for (int i = 0; i < m; i++)
	{
		int s, t;
		cin >> s >> t;
		mas.push_back({ s,t });
	}
	mas.push_back({ 1,n });
	int64_t ans = 0;
	while (mas.size() > 1)
	{
		int s1 = mas[0].first, t1 = mas[0].second, s2 = mas[1].first, t2 = mas[1].second;
		if (t1 >= s2 and t2 >= s1)
		{
			mas.pop_front();
			continue;
		}
		int s, t;
		if (t1 < s2)
		{
			ans += s2 - t1;
			s = t1, t = t2;
		}
		else
		{
			ans += s1 - t2;
			s = s2, t = s1;
		}
		mas.pop_front();
		mas.pop_front();
		mas.push_front({ s,t });
	}
	cout << ans;
}