#define _CRT_SECURE_NO_WARNINGS
#define _GLIB_CXX_DEBUG
#define INF 1000000000
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <iomanip>
#include <sstream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define ff first
#define ss second
//#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;

template<typename T>
bool rMin(T& x, const T& y)
{
    if (x > y)
    {
        x = y;
        return true;
    }
    return false;
}
template<typename T>
bool rMax(T& x, const T& y)
{
    if (x < y)
    {
        x = y;
        return true;
    }
    return false;
}

bool used[200002];

void solve()
{
    ll n, a, b, sum = 0;

    cin >> n >> a >> b;

    vector<ll> x(n);
    vector<ll> y(n);
    vector<pair<ll, int>> d(n);

    for (int i = 0; i < n; i++)
    {
        cin >> x[i];
    }

    for (int i = 0; i < n; i++)
    {
        cin >> y[i];
    }

    for (int i = 0; i < n; i++)
    {
        d[i] = { x[i] - y[i], i };
    }

    sort(d.begin(), d.end());

    for (int i = 0; i < b; i++)
    {
        used[d[i].ss] = false;
        sum += y[d[i].ss];
    }
    
    for (int i = d.size() - a; i < n; i++)
    {
        used[d[i].ss] = true;
        sum += x[d[i].ss];
    }

    ll t = 0, p = 0;

    for (int i = b; i < d.size() - a; i++)
    {
        if (x[d[i].ss] > y[d[i].ss])
        {
            ++t;
            used[d[i].ss] = true;
            sum += x[d[i].ss];
        }
        else
        {
            ++p;
            used[d[i].ss] = false;
            sum += y[d[i].ss];
        }
    }

    cout << sum << endl;

    for (int i = 0; i < n; i++)
    {
        if (used[i])
        {
            cout << "T ";
        }
        else
        {
            cout << "P ";
        }
    }

    cout << endl;
}


int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(12);

    solve();
}