#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <queue>
#include <cmath>
#include <cstdlib>

#define fori(a, b) for(int i = a; i < b; ++i)
#define forj(a, b) for(int j = a; j < b; ++j)
#define fork(a, b) for(int k = a; k < b; ++k)
#define forn(n) for(int i = 0; i < n; ++i)
#define X first
#define Y second
#define mp make_pair

using namespace std;

typedef long long ll;         
typedef long double ld;         
typedef unsigned long long ull;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, cnt;
    cin >> n;
    string s;
    vector<int> a(n);
    set<char> vol = {'a', 'e', 'i', 'u', 'o'};
    forn(n){
	cin >> s, cnt = 0;
	for (int j = 0; j < s.size(); ++j) {
	    if (vol.find(s[j]) != vol.end()) cnt++;
	    while (vol.find(s[j]) != vol.end())	j++;
	}
	a[i] = cnt;
    }
    int r = 1, su = a[0], s1, s2, x;
    ll res = 0;
    for (int l = 0; l < n; ++l){
	s1 = s2 = 0;
	while (r < n && su < 17) su += a[r], r++;
	if (su < 17) break;
	if (su > 17) {
	    su -= a[l]; 
	    continue;
	}
	for (x = l; x < r && s1 < 5; ++x) s1 += a[x];
	if (s1 != 5) {
	    su -= a[l];
	    continue;
	}
	for (; x < r && s2 < 7; ++x) s2 += a[x];
	res += (s2 == 7);
	su -= a[l];
    }
    cout << res << endl;
    return 0;
}