#include<iostream>
#include<queue>
#include<vector>
#define ll long long
using namespace std;
ll Ans[200005];
ll Guardians[200005];
ll x;
bool Used[200005];
vector<ll> Graph[200005];
void Dejkstra(ll Node) {
	priority_queue<pair<ll, ll>> q;
	if (Guardians[Node] >= x) x /= 2;
	q.push({ x,Node });
	while (q.size()) {
		ll y = q.top().first;
		Node = q.top().second;
		q.pop();
		if (Used[Node]){
			continue;
		}
		Used[Node] = true;
		Ans[Node] = y;
		for (int To : Graph[Node]) {
			if (Guardians[To] >= y) {
				q.push({ y / 2,To });
			}
			else q.push({ y,To });
		}
	}
}
int main() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		Graph[a].push_back(b);
		Graph[b].push_back(a);
	}
	cin >> x;
	for (ll i = 1; i <= n; i++) {
		cin >> Guardians[i];
	}
	Dejkstra(1);
	cout << Ans[n] << endl;
}