#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x) * (x))

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;



void solve() {
	int n;
	cin >> n;
	int ans = 2;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	for (int i = 0; i < n; ++i) {
		vector<vector<int>> stm;
		for (int j = 0; j < n; ++j) {
			if (j == i) continue;
			stm.push_back({ a[i].first - a[j].first, a[i].second - a[j].second });
		}
		for (int j1 = 0; j1 < n - 1; ++j1) {
			for (int j2 = j1 + 1; j2 < n - 1; ++j2) {
				if ((stm[j1][0] == stm[j2][0] && stm[j1][1] == stm[j2][1]) || (stm[j1][1] - stm[j2][1] != 0 && (stm[j1][0] - stm[j2][0]) % (stm[j1][1] - stm[j2][1]) == 0)) {
					int k = (stm[j1][0] - stm[j2][0]) / (stm[j1][1] - stm[j2][1]), tmp_ans = 3;
					int t = stm[j1][0] + k * stm[j2][1];
					for (int j3 = 0; j3 < n - 1; ++j3) {
						if (j3 == j1 || j3 == j2) continue;
						if (stm[j3][0] + stm[j3][1] * k == t) {
							tmp_ans++;
						}
					}
					ans = max(ans, tmp_ans);
					if (ans == n) {
						cout << ans;
						return;
					}
				}
			}
		}
	}
	cout << ans;
}


signed main() {
	ios::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	int t = 1;
	//	gen.seed(time(0));
	//	cout << fixed;
	//	cout.precision(15);
	//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
