#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x) * (x))

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;



void solve() {
	ld x, T;
	cin >> x >> T;
	ld k1 = 6 * x / T, k2 = 6 * (100 - x) / T;
	ld L = 0, R = T / 6;
	ld ans1 = 0, ans2 = 0, ans3 = 0;

	for (int i = 0; i < 300; ++i) {
		ld M1 = L + (R - L) / 3, M2 = R -  (R - L) / 3;
		if (k1 * M1 * (T - M1) < k1 * M2 * (T - M2)) {
			L = M1;
		}
		else {
			R = M2;
		}
	}
	ld M1 = L + (R - L) / 3, M2 = R - (R - L) / 3;
	ans1 = max(k1 * M1 * (T - M1), k1 * M2 * (T - M2));
	L = T / 6, R = T / 3;
	for (int i = 0; i < 300; ++i) {
		ld M1 = L + (R - L) / 3, M2 = R - (R - L) / 3;
		if ((k2 * (M1 - T / 6) + x) * (T - M1) < (k2 * (M2 - T / 6) + x) * (T - M2)) {
			L = M1;
		}
		else {
			R = M2;
		}
	}
	M1 = L + (R - L) / 3, M2 = R - (R - L) / 3;
	ans2 = max((k2 * (M1 - T / 6) + x) * (T - M1), (k2 * (M2 - T / 6) + x) * (T - M2));
	ans3 = 200 * T / 3;
	cout << max({ ans1, ans2, ans3 });
}


signed main() {
	ios::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	int t = 1;
	//	gen.seed(time(0));
	//	cout << fixed;
		cout.precision(15);
	//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
