#include <bits/stdc++.h>
#include <bits/extc++.h>

#define sz(v) int (v.size())
#define ff first
#define int long long
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(),a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; };
/// Actual code starts here
const int N = 100005, INF = MOD;

int l[N], r[N];

struct minq {
    deque<int> q;

    void push(int x) {
        while (!q.empty() && q.back() > x)
            q.pop_back();
        q.push_back(x);
    }

    int getmin() {
        return q.front();
    }

    void pop(int x) {
        if (q.front() == x)
            q.pop_front();
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i)
        cin >> l[i] >> r[i], --l[i], --r[i];

    vector<vector<int>> dp(m, vector<int>(n));
    for (int j = 0; j < n; ++j) {
        if (j + r[0] - l[0] >= n) dp[0][j] = INF;
        else dp[0][j] = abs(l[0] - j);
    }
    for (int i = 1; i < m; ++i) {
        minq q;
        for (int j = 0; j < r[i] - l[i]; ++j)
            q.push(dp[i - 1][j]);
        for (int j = 0; j < n; ++j) {
            if (j + r[i] - l[i] >= n) dp[i][j] = INF;
            else {
                q.push(dp[i - 1][j + r[i] - l[i]]);
                dp[i][j] = abs(l[i] - j) + q.getmin();
                int del = j - (r[i - 1] - l[i - 1]);
                if (del >= 0)
                    q.pop(dp[i - 1][del]);
            }
        }
    }
    int ans = INF;
    for (int i = 0; i < n; ++i)
        ans = min(ans, dp[m - 1][i]);
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    freopen("input.txt", "r", stdin);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
