#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

long long sign(long long a) {
    if (a == 0) {
        return 0;
    }
    return a / abs(a);
}

void solve() {

    long long a, b;
    cin >> a >> b;
    vector<pair<long long, long long>> ans;
    while (sign(a) * sign(b)) {
        long long absa = abs(a), absb = abs(b);
        if (absa >= absb) {
            long long k = absa / absb;
            long long newa1 = absa % absb * sign(absa), newa2 = (absa % absb - absb) * sign(absa);
            if (abs(newa1) <= abs(newa2)) {
                ans.emplace_back(1, -k * sign(a) * sign(b));
                a = newa1;
            }
            else {
                ans.emplace_back(1, -(k + 1ll) * sign(a) * sign(b));
                a = newa2;
            }
        }
        else {
            long long k = absb / absa;
            long long newb1 = absb % absa * sign(absb), newb2 = (absb % absa - absa) * sign(absb);
            if (abs(newb1) <= abs(newb2)) {
                ans.emplace_back(2, -k * sign(a) * sign(b));
                b = newb1;
            }
            else {
                ans.emplace_back(2, -(k + 1ll) * sign(a) * sign(b));
                b = newb2;
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto par : ans) {
        cout << par.first << " " << par.second << "\n";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}