const val ONLINE_JUDGE = true //I'm not sure if it exists

fun main() {
    if (!ONLINE_JUDGE) {
        System.setIn(
            (
                    "4 4\n" +
                            "1 2\n" +
                            "1 3\n" +
                            "2 4\n" +
                            "3 4\n" +
                            "7\n" +
                            "10 3 3 1\n"
                    ).byteInputStream()
        )
    }

    solveD()
}

fun solveD() {
    val (v, e) = intArr()
    val neighbors = List(v) { mutableListOf<Int>() }
    repeat(e) {
        val (a, b) = intArr()
        neighbors[a - 1].add(b - 1)
        neighbors[b - 1].add(a - 1)
    }

    val x = int()
    val droids = intArr()

    val cameWith = IntArray(v)
    cameWith[0] = if (x > droids[0]) x else x / 2

    fun dfs(i: Int) {
        val was = cameWith[i]
        for (nei in neighbors[i]) {
            val became = if (was > droids[nei]) was else was / 2
            if (became > cameWith[nei]) {
                cameWith[nei] = became
                if (i != v - 1) dfs(nei)
            }
        }
    }

    dfs(0)
    println(cameWith.last())
}

fun solveA() {
    val (r, c, n) = intArr()
    if (n > r || n > c) return println("Impossible")
    println("Possible")
    val line = ".".repeat(c)
    if (r < c) {
        for (i in 0 until n) println(".".repeat(i) + "*" + ".".repeat(c - i - 1))
    } else {
        for (i in 0 until n) println(".".repeat(i) + "*" + ".".repeat(c - i - 1))
    }
    repeat(r - n) { println(line) }
}

fun line() = readLine()!!
fun int() = readLine()!!.trim().toInt()
fun intArr() = readLine()!!.trim().split(" ").mapNotNullTo(mutableListOf()) { if (it == "") null else it.toInt() }
fun intArr2(rows: Int) = List(rows) { intArr() }