#include <algorithm>
#include <cmath>
#include <iostream>
#include <set>
#include <string>
#include <vector>

using namespace std;
using ll = long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  int n;
  cin >> n;

  vector<int> a;
  for (int i = 0; i < n; i++) {
    string s;
    cin >> s;

    set<char> valid = {'a', 'e', 'i', 'o', 'u'};
    int cnt = 0;
    for (int i = 0; i < s.length() - 1; i++) {
      if (valid.find(s[i]) != valid.end() &&
          valid.find(s[i + 1]) == valid.end())
        cnt++;
    }

    if (valid.find(s[s.length() - 1]) != valid.end())
      cnt++;

    a.push_back(cnt);
  }
  int ans = 0;
  for (int i = 0; i < n; i++) {
    int curr = 0, j = i;
    for (; curr < 5 && j < n; j++)
      curr += a[j];

    if (curr != 5)
      continue;

    curr = 0;
    for (; curr < 7 && j < n; j++)
      curr += a[j];

    if (curr != 7)
      continue;

    curr = 0;
    for (; curr < 5 && j < n; j++)
      curr += a[j];

    if (curr != 5)
      continue;

    ans++;
  }

  cout << ans;
}