#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

int depth = 0;
int cur = 0;

vector<pair<int, int>> rec;

void gcd(int a, int b) {
    if (b == 0) {
        return;
    }

    ++depth;

    rec.push_back({cur + 1, -a / b});
    cur ^= 1;

    gcd(b, a % b);
}

int g(int a, int b) {
    if (b == 0)
        return a;
    return g(b, a % b);
}

int am(int x) {
    if (x < 0)
        return -x;
    return x;
}

void solve() {
    int a, b;
    cin >> a >> b;

    for (int q = 0; ; ++q) {
        int ta = a, tb = b;

        if (q) {
            if (rand() % 2 == 0) {
                ta -= tb * q;
                rec = {{1, -q}};
            }
            else {
                ta += tb * q;
                rec = {{1, q}};
            }
        }

        if (am(ta) > 1e18)
            continue;

        if (am(ta) < am(tb)) {
            cur = 1;
            swap(ta, tb);
        }
        gcd(ta, tb);

        if (rec.size() > 50)
            continue;
        cout << rec.size() << endl;
        for (auto e : rec)
            cout << (ll)e.x << " " << (ll)e.y << endl;
        break;
    }

}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    cout.precision(16);

    solve();
}
