/* 14.11.2021 */

#include <stdio.h>
#include <stdlib.h>


typedef signed long UL;
typedef struct 
{
  UL y1, y2, d;
} point;

point *mas;

UL absl( UL a )
{
  return labs(a);
}

void pointMov( UL nx, UL n )
{
  mas[nx].y1 += n;
  mas[nx].y2 += n;
  mas[nx].d += n;
}

void masMov( UL nx, UL n )
{
  while (nx >= 0)
    pointMov(nx--, n);
}

UL absSum( UL nx )
{
  UL sum = 0;

  while (nx >= 0)
    sum += absl(mas[nx--].d);

  return sum;
}

int isConnecting( UL a, UL b )
{
  if (mas[a].y1 >= mas[b].y1 && mas[a].y1 <= mas[b].y2)
    return 1;
  if (mas[a].y2 >= mas[b].y1 && mas[a].y2 <= mas[b].y2)
    return 1;
  if (mas[b].y1 >= mas[a].y1 && mas[b].y2 <= mas[a].y2)
    return 1;
  return 0;
}
int delta( UL nx )
{
  if (absl(mas[nx - 1].y1 - mas[nx].y2) > absl(mas[nx].y1 - mas[nx - 1].y2))
    return absl(mas[nx].y1 - mas[nx - 1].y2);
  else
    return absl(mas[nx - 1].y1 - mas[nx].y2);
}

int main( void )
{
  UL sx, sy, i, nx, ny1, ny2, d, minShift, msi, sum, maxy1, maxy2;
  
  scanf("%ld%ld", &sy, &sx);
  mas = malloc(sx * sizeof(point));
  for (i = 0; i < sx; i++)
  {
    scanf("%ld%ld", &ny1, &ny2);
    mas[i].y1 = ny1;
    mas[i].y2 = ny2;
    mas[i].d = 0;
  }
  maxy1 = mas[0].y1;
  maxy2 = mas[0].y2;
  for (nx = 1; nx < sx; nx++)
  {
    if (!isConnecting(nx, nx - 1))
    {
      for (i = 0, d = delta(nx), minShift = 0xFFFFFF; i <= d; i++)
      {
        if (maxy1 < mas[nx].y1)
          maxy1 = mas[nx].y1;
        if (maxy2 < mas[nx].y2)
          maxy2 = mas[nx].y2;
        if (maxy1 >= 0 && maxy2 <= sy)
        {
          //Shift = absl((nx - 1) * i) + absl(d - i);
          if (absl((nx - 1) * i) + absl(d - i) < minShift)
            msi = i, minShift = (nx - 1) * i + d - i;
        }
      }
      masMov(nx - 1, msi);
      mas[nx].d += minShift;
      absSum(nx);
    }
    /*for (j = 0; j <= i; j++)
      printf("%ld, %ld, %ld\n", mas[j].y1, mas[j].y2, mas[j].d);
    printf("\n");*/
  }
  for (i = 0, sum = 0; i < sx; i++)
  {
    sum += absl(mas[i].d);
    /*printf("%ld, %ld, %ld\n", mas[i].y1, mas[i].y2, mas[i].d);*/
  }
  printf("%d", sum);
  return 0;
}