#include <iostream>
#include <cmath>

int64_t Power( int64_t a, int n )
{
  int64_t aa = a;
  if (n == 0)
    return 1;

  for (int i = 0; i < n - 1; i++)
    a *= aa;

  return a;     
}

int64_t Reverse( int64_t a )
{
  int64_t sum =  0, aa = a;
  int st = 0, dop = (aa /= 10), dd = 1;

  while (dop != 0)
  {
    st++;
    dop = (aa /= 10);
  }

  for (int i = 0; i < st; i++)
  {    
    int dz = a % Power(10, i + 1) / dd;
    a -= dz;
    sum += dz * Power(10, st - i);
    dd *= 10;
  }

  sum += a / Power(10, st);

  return sum;
}

int IsPow2( int64_t a )
{
  double x = sqrt(a);

  if (x == (int)x)
    return 1;

  return 0;
}

int main( void )
{
  int64_t a, b, Sqra, Sqrb;
  int full = 0;

  std::cin >> a >> b;

  Sqra = ceil(sqrt(a));
  Sqrb = (int64_t)sqrt(b);
  
  for (; Sqra <= Sqrb; Sqra++)
  {
    if (IsPow2(Reverse(Sqra * Sqra)) && ((Sqra % 10) != 0 || Sqra < 10))
      full++;
  }

  std::cout << full;

  return 0;
}