﻿//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("rename-registers")

#include <bits/stdc++.h>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define all(c) begin(c), end(c)
//typedef __int128_t bigint;
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;


vector<vector<pair<int, int>>> g;
int n;
int root = 1;
int inf = INT_MIN;
int x;
vector<int> clones;

int dijkstra() {
    vector<int> d(n + 1, inf);
//    vector<int> clonesCnt(n, 0);
    int tmp = x;
    if (clones[0] >= x) {
        x /= 2;
    }
    d[1] = x;

    set<pair<int, int> > q;
    q.insert({-x, 1});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto[u, w] : g[v]) {
            int cntCloneV = d[v];
            int cntCloneInU = w;
            int dist;
            if (cntCloneV > cntCloneInU) {
                dist = cntCloneV;
            } else {
                dist = cntCloneV / 2;
            }
            if (d[u] < dist) {
                q.erase({-d[u], u});
                d[u] = dist;
                q.insert({-d[u], u});
            }
        }
    }
    return d[n];
}


int32_t main() {
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(nullptr);
    //    cout.tie(nullptr);
    //
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    int m;
    cin >> n >> m;
    g.resize(n + 1);
    vector<pair<int, int>> edges(m);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        edges[i] = {a, b};
    }

    cin >> x;
    clones.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> clones[i];
    }
    for (int i = 0; i < m; ++i) {
        auto[u, v] = edges[i];
        g[u].push_back(make_pair(v, clones[v - 1]));
        g[v].push_back(make_pair(u, clones[u - 1]));
    }
    int kok = dijkstra();
    if (kok <= 0) cout << 0;
    else cout << kok;





    // очередной абц контест понятно
}