#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include <climits>
#include <algorithm>
#include <cmath>

using namespace std;

const int INF = 1e9 + 7;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int a, b, k = 0;
    cin >> a >> b;

    for (int i = a; i * i <= b; i++)
    {
        int b = i * i;
        string c = to_string(b);
        reverse(c.begin(), c.end());
        int d = stoi(c);
        if ((int)sqrt(d) * (int)sqrt(d) == d && c.length() == to_string(d).length())
            k++;
    }
    cout << k;
    return 0;
}