#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;
using sl = set<long long>;
using ss = set<string>;
using usl = unordered_set<ll>;
using ml = map<long long, long long>;
using pl = pair<long long, long long>;
using ql = queue<long long>;
using vp = vector<pair<ll, ll>>;
using dl = deque<ll>;
const ll MAX = 2e9 + 1;
const ll MIN = -(2e9 + 1);
const ll MOD = 1e9;
const double eps = 1e-9;
const double PI = acos(-1);

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define rev(a) reverse(all(a));
#define sort(a) sort(all(a));
#define IOS ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define vvl(n,m) vvl(n, vl m);

template<typename T>
istream& operator>>(istream& a, vector<T>& b)
{
	for (T& i : b) a >> i; return a;
}

long long n, m;

long long mx = 0;
vector<bool> used;

void foo(vector<set<long long>>& gr,vector<long long> &a, long long x, long long v) {
	if (x <= a[v]) {
		x = x / 2;
	}
	if (x == 0) {
		return;
	}
	if (v == n - 1) {
		if (mx < x) {
			mx = x;
		}
		return;
	}
	for (auto to : gr[v]) {
		if (!used[to]) {
			used[to] = true;
			foo(gr, a, x, to);
			used[to] = false;
		}
	}
}

int main() {
	IOS;
	cin >> n >> m;
	vector<set<long long>> gr(n);
	for (long long i = 0; i < m; i++) {
		long long l, r;
		cin >> l >> r;
		gr[l - 1].insert(r - 1);
		gr[r - 1].insert(l - 1);
	}
	long long x;
	cin >> x;
	vector<long long> a(n);
	for (long long i = 0; i < n; i++) {
		cin >> a[i];
	}
	used.assign(n, false);
	used[0] = true;
	foo(gr, a, x, 0);
	cout << mx;
}
/*
double x, t;
	cin >> x >> t;
	double t6 = t / 6, t3 = t / 3;
	double l = 0.000000, r = 100.000000, ans = 0.000000;
	while (r - l > 0.000001) {
		double m = (l + r) / 2, T;
		if (m <= x) {
			T = (t6 / 100) * ((x / 100) * m);
		}
		if (m > x) {
			T = (t3 / 100) * m;
		}
		double f = (t - T) * m;
		if (f >= ans) {
			l = m;
			ans = f;
		}
		else {
			r = m;
			ans = f;
		}
	}
	cout << fixed << setprecision(8);
	cout << ans << " " << l << " " << r;
*/