#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstdint>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <random>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define ff first
#define ss second
#define pb push_back
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

pair<int, pair<int, int>> ask(int l, int r) {
    cout << "? " << l + 1 << ' ' << r + 1 << endl;

    int sum; cin >> sum;

    int lb, rb;
    cin >> lb >> rb;
    --lb, --rb;

    return {sum, {lb, rb}};
} 

void solve() {
    int n;
    cin >> n;

    vector<int> a(n), ps(n);
    vector<char> type(n);

    vector<bool> depr(n), depr1(n);

    int cnt = 0, nxt = 0;

    set<int> may;
    forn(i, n) may.insert(i);
    while (!may.empty()) {
        if (may.count(nxt) == 0) {
            nxt = *may.begin();
        }

        assert(!(depr1[nxt] && depr[nxt]));
        may.erase(nxt);
        pair<int, pair<int, int>> val;
        if (depr[nxt]) {
            val = ask(0, nxt);
            ps[nxt] = val.ff;
            type[nxt] = 2;
        } else {
            val = ask(nxt, nxt);
            a[nxt] = val.ff;
            type[nxt] = 1;
        }

        if (val.ss.ff == val.ss.ss) {
            nxt = val.ss.ff;
            depr[nxt] = true;
        } else if (val.ss.ff == 0) {
            depr1[val.ss.ff] = true;
            nxt = val.ss.ss;
        } else {
            nxt = 0;
        }
    }

    int psum = 0;
    forn(i, n) {
        if (type[i] == 2) 
            a[i] = ps[i] - psum;

        psum += a[i];
    }

    cout << "!" << '\n';
    forn(i, n) cout << a[i] << ' ';
    cout << endl;
}

signed main() {
// #ifdef LOCAL
    // freopen("input.txt", "r", stdin);
//     freopen("output.txt", "w", stdout);
// #endif
//     fastio();
    int tt = 1;
    // cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
