﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <bitset>
#include <optional>
using namespace std;


int get_slogan_from_word(string word) {
	int result = 0;
	for (int i = 0; i < word.size(); ++i) {
		if (word[i] == 'a') result++;
	}

	return result;
}

bool is_ok(vector<string> s) {
	int second_line_begin = 0;

	// 1 line

	// words
	for (int i = 0; i < s.size(); ++i) {
		int words_slogan = 0;

		// first line words
		for (int j = 0; j < i; ++j) {
			words_slogan += get_slogan_from_word(s[j]);
		}

		if (words_slogan == 5) {
			second_line_begin = i + 1;
			break;
		}
		else if (words_slogan > 5) {
			return false;
		}
	}

	int third_line_begin = 0;

	// 2 line

	for (int i = second_line_begin; i < s.size(); ++i) {
		int words_slogan = 0;

		// second line words
		for (int j = second_line_begin; j < i; ++j) {
			words_slogan += get_slogan_from_word(s[j]);
		}

		if (words_slogan == 7) {
			third_line_begin = i + 1;
			break;
		}
		else if (words_slogan > 7) {
			return false;
		}
	}

	// 3 line

	for (int i = third_line_begin; i < s.size(); ++i) {
		int words_slogan = 0;

		// third line words
		for (int j = third_line_begin; j < i; ++j) {
			words_slogan += get_slogan_from_word(s[j]);
		}

		if (words_slogan == 5) {
			break;
		}
		else if (words_slogan > 5) {
			return false;
		}
	}

	return true;
}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n;
	cin >> n;

	vector<string> s(n);
	
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}

	for (int i = 0; i < s.size(); ++i) {
		replace(s[i].begin(), s[i].end(), 'e', 'a');
		replace(s[i].begin(), s[i].end(), 'i', 'a');
		replace(s[i].begin(), s[i].end(), 'o', 'a');
		replace(s[i].begin(), s[i].end(), 'u', 'a');
	}

	for (int i = 0; i < s.size(); ++i) {
		for (int j = 0; j < s[i].size() - 1; ++j) {
			if (s[i][j] == s[i][j + 1]) {
				s[i].erase(s[i].begin() + j);
				j -= 1;
			}
		}
	}

	int result_count = 0;

	for (int i = 0; i < s.size(); ++i) {
		if (is_ok(s)) {
			result_count++;
		}

		std::next_permutation(s.begin(), s.end());
	}

	

	cout << result_count / 5 << endl;

	return 0;
}