﻿#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <functional>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <array>
#include <random>
#include <chrono>

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
using namespace std;
using namespace std::chrono;

#define all(x) x.begin(), x.end()
#define ll long long

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
}

const int N = 2e5 + 1;
const int INF = 2e9;

double x, t;

double ts(double l, double r, double k, double p, double OLALA) {
	for (int i = 0; i < 228; i++) {
		double d = r - l;
		double l1 = l + d / 3, r1 = r - d / 3;
		double v1 = (t - l1) * (OLALA - k * (p - l1));
		double v2 = (t - r1) * (OLALA - k * (p - r1));
		if (v1 > v2) {
			r = r1;
		}
		else {
			l = l1;
		}
	}
	return (t - l) * (OLALA - k * (p - l));
}

void solve() {
	cout << setprecision(13);
	cin >> x >> t;
	double ans = t / 3;
	ans = max(ans, ts(t / 6, t / 3, (100 - x) / (t / 3 - t / 6), t / 3, 100));
	ans = max(ans, ts(0, t / 6, x / (t / 6), t / 6, x));
	cout << ans << '\n';
}

signed main() {
	//ios_base::sync_with_stdio(false);
	//cin.tie(0); cout.tie(0);
	//freopen("game.in", "r", stdin);
	//freopen("game.out", "w", stdout);
	int _t = 1; //cin >> _t;
	while (_t--) {
		solve();
		//gen();
	}
}