#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include <bits/stdc++.h>

#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

void solve()
{
    ll n, a, b;
    cin >> n >> a >> b;
    vector<int> th(n), pr(n);
    for (auto &i : th)
        cin >> i;
    for (auto &i : pr)
        cin >> i;
    vector<vector<ll>> dp(n + 2, vector<ll>(n + 2, 0));
    vector<vector<ll>> ans(n + 2, vector<ll>(n + 2, 0));
    dp[1][0] = pr[0];
    dp[1][1] = th[0];
    ans[1][0] = 0;
    ans[1][1] = 1;
    for (int i = 2; i <= n; ++i)
    {
        for (int j = 0; j <= i; ++j)
        {
            ll t1 = dp[i - 1][j] + th[i - 1],
               t2 = dp[i - 1][j + 1] + pr[i - 1],
               t3 = dp[i - 1][j] + pr[i - 1];
            if (t1 > dp[i][j + 1])
            {
                dp[i][j + 1] = t1;
                ans[i][j + 1] = 1;
            }
            if (t2 > dp[i][j + 1])
            {
                dp[i][j + 1] = t2;
                ans[i][j + 1] = 0;
            }
            if (t3 > dp[i][j])
            {
                dp[i][j] = t3;
                ans[i][j] = 0;
            }
        }
    }
    ll ans1 = 0;
    ll ii = 0;
    for (int i = a; n - i >= b; ++i)
    {
        if (dp[n][i] > ans1)
        {
            ii = i;
            ans1 = dp[n][i];
        }
    }
    cout << ans1 << "\n";
    ll curi = n, curj = ii;
    vector<char> ans2;
    while (curi > 0)
    {
        int x = ans[curi--][curj];
        ans2.push_back(x ? 'T' : 'P');
        curj -= x;
    }
    for (auto i = n - 1; i >= 0; --i){cout << ans2[i] << " ";}
}

int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    ll _ = 1;
    // cin >> _;
    while (_--)
        solve();
}