//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>

//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& i : a) {
        out << a;
    }
    return out;
}

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))

void solve(){
    int n;
    cin >> n;
    vector<string> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++){
        int f = 0;
        for (int j = 0; j < (int)s[i].size(); j++){
            if (s[i][j] == 'a' || s[i][j] == 'e' || s[i][j] == 'i' || s[i][j] == 'o' || s[i][j] == 'u'){
                f = 1;
            }
            else{
                p[i] += f;
                f = 0;
            }
        }
        if (f == 1){
            p[i]++;
        }
    }
    vector<int> pr5(n, -1), pr7(n, -1);
    vector<int> sum(n + 1, 0);
    for (int i = 1; i <= n; i++){
        sum[i] = sum[i - 1] + p[i - 1];
    }
    for (int i = 0; i < n; i++){
        int j = i + 1;
        while (j <= n && sum[j] - sum[i] < 5){
            j++;
        }
        if (sum[j] - sum[i] == 5){
            pr5[i] = j;
        }
        j = i + 1;
        while (j <= n && sum[j] - sum[i] < 7){
            j++;
        }
        if (sum[j] - sum[i] == 7){
            pr7[i] = j;
        }

    }
    int cnt = 0;
    for (int i = 0; i < n; i++){
        if (pr5[i] != -1){
            if ((pr5[i] < n) && (pr7[pr5[i]] != -1)){
                if ((pr7[pr5[i]] < n) && (pr5[pr7[pr5[i]]] != -1)){
                    cnt++;
                }
            }
        }
    }
    cout << cnt;
    return;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    solve();
    return 0;
}
